/******************************************************************************/
/* SISTEMAS INTEGRADOS TECNISA                                                */
/* NOME: 0052_STPSDXO_USR_IMPORTA_AF.SQL                                      */
/*                                                                            */
/* DESCRIO:                                                                 */
/* REALIZA A IMPORTAO DAS AF'S GERADAS PELO SISTEMA SAC PARA O TECFOOD      */
/* CRIAO:                                                                   */
/* 12/06/2008 - RAQUEL CUNHA                                                  */
/******************************************************************************/

CREATE OR REPLACE
PROCEDURE USR_IMPORTA_AF
  (P_CDFILLANC IN VARCHAR2,
   P_CDFILIAL IN VARCHAR2 DEFAULT NULL,
   P_ATUALIZAR IN VARCHAR2 DEFAULT 'N') IS

   V_CDPRODUTO VARCHAR(10);
   V_CDFILIAL VARCHAR(4);
   V_CDEMPRESA VARCHAR(2);
   V_CDFORNECED VARCHAR(21);
   V_IDTPIJURFORN VARCHAR(1);
   V_NRINSJURFORN VARCHAR(20);
   V_EXIST_PROD VARCHAR(10);
   V_NRAUTOFORN VARCHAR(10);
   V_IDTIPEMITGER VARCHAR(1);
   V_CODIGO VARCHAR2(20);
   V_LISTA  VARCHAR2(20);

   V_AF_SOLFIL_IDSOL NUMBER;
   V_AF_PEDIDO_CDPED NUMBER;
   V_AF_CPOPRO_CDPRO VARCHAR(20);
   V_AF_SOLITE_DTENT DATE;
   V_AF_SOLFIL_DTREF DATE;
   V_AF_CADFIL_CDFIL VARCHAR(4);
   V_AF_CADFOR_NRCGC VARCHAR(15);
   V_AF_SOLITE_VLPCO NUMBER;
   V_AF_SOLITE_QTSOL NUMBER;
   V_AF_SOLITE_QTCPA NUMBER;
   V_AF_CDIMPORTAF   VARCHAR(1);

   V_ANT_CDFORNECED  VARCHAR2(21);
   V_ANT_CDFILDEST   VARCHAR2(4);
   V_ANT_CDPED       NUMBER;

   CURSOR C_AF IS
      SELECT
         SAC.SOLFIL_IDSOL, SAC.PEDIDO_CDPED, SAC.CPOPRO_CDPRO,
         SAC.SOLITE_DTENT, SAC.CADFIL_CDFIL, TRIM(SAC.CADFOR_NRCGC),
         TO_DATE(SAC.SOLFIL_DTREF||'01', 'YYYYMMDD'), SAC.SOLITE_VLPCO, SAC.SOLITE_QTSOL,
         SAC.SOLITE_QTCPA, SAC2.CDIMPORTAF
      FROM
         CMPPROD.VW_SACA2B_AF@SDXLOGIS SAC,
         CMPPROD.ITEMAF_SACA2B@SDXLOGIS SAC2
      WHERE
         SAC.SOLFIL_IDSOL = SAC2.SOLFIL_IDSOL(+) AND
         SAC.PEDIDO_CDPED = SAC2.PEDIDO_CDPED(+) AND
         SAC.CPOPRO_CDPRO = SAC2.CPOPRO_CDPRO(+) AND
         SAC.SOLITE_DTENT = SAC2.SOLITE_DTENT(+) AND
         NVL(SAC2.CDIMPORTAF, 'S') = 'S'
      ORDER BY
         SAC.CADFIL_CDFIL, TRIM(SAC.CADFOR_NRCGC), SAC.PEDIDO_CDPED;

   CURSOR C_AFFILI IS
      SELECT
         SAC.SOLFIL_IDSOL, SAC.PEDIDO_CDPED, SAC.CPOPRO_CDPRO,
         SAC.SOLITE_DTENT, SAC.CADFIL_CDFIL, TRIM(SAC.CADFOR_NRCGC),
         TO_DATE(SAC.SOLFIL_DTREF||'01', 'YYYYMMDD'), SAC.SOLITE_VLPCO, SAC.SOLITE_QTSOL,
         SAC.SOLITE_QTCPA, SAC2.CDIMPORTAF
      FROM
         CMPPROD.VW_SACA2B_AF@SDXLOGIS SAC,
         CMPPROD.ITEMAF_SACA2B@SDXLOGIS SAC2
      WHERE
         SAC.SOLFIL_IDSOL = SAC2.SOLFIL_IDSOL(+) AND
         SAC.PEDIDO_CDPED = SAC2.PEDIDO_CDPED(+) AND
         SAC.CPOPRO_CDPRO = SAC2.CPOPRO_CDPRO(+) AND
         SAC.SOLITE_DTENT = SAC2.SOLITE_DTENT(+) AND
         NVL(SAC2.CDIMPORTAF, 'S') = 'S'         AND
         SAC.CADFIL_CDFIL = P_CDFILIAL
      ORDER BY
         SAC.CADFIL_CDFIL, TRIM(SAC.CADFOR_NRCGC), SAC.PEDIDO_CDPED;
BEGIN
   V_ANT_CDFORNECED := NULL;
   V_ANT_CDFILDEST  := NULL;
   V_ANT_CDPED      := NULL;
   V_LISTA          := NULL;
   IF P_CDFILIAL IS NULL THEN
      OPEN C_AF;
   ELSE
      OPEN C_AFFILI;
   END IF;
   LOOP
      IF P_CDFILIAL IS NULL THEN
         FETCH C_AF INTO V_AF_SOLFIL_IDSOL,
                         V_AF_PEDIDO_CDPED,
                         V_AF_CPOPRO_CDPRO,
                         V_AF_SOLITE_DTENT,
                         V_AF_CADFIL_CDFIL,
                         V_AF_CADFOR_NRCGC,
                         V_AF_SOLFIL_DTREF,
                         V_AF_SOLITE_VLPCO,
                         V_AF_SOLITE_QTSOL,
                         V_AF_SOLITE_QTCPA,
                         V_AF_CDIMPORTAF;
         EXIT WHEN C_AF%NOTFOUND;
      ELSE
         FETCH C_AFFILI INTO V_AF_SOLFIL_IDSOL,
                             V_AF_PEDIDO_CDPED,
                             V_AF_CPOPRO_CDPRO,
                             V_AF_SOLITE_DTENT,
                             V_AF_CADFIL_CDFIL,
                             V_AF_CADFOR_NRCGC,
                             V_AF_SOLFIL_DTREF,
                             V_AF_SOLITE_VLPCO,
                             V_AF_SOLITE_QTSOL,
                             V_AF_SOLITE_QTCPA,
                             V_AF_CDIMPORTAF;
         EXIT WHEN C_AFFILI%NOTFOUND;
      END IF;
      SELECT
         MAX(CDPRODUTO)
      INTO
         V_CDPRODUTO
      FROM
         PRODINTDOS
      WHERE
          IDPRODINTDOS = 'G'
      AND CDPRODINTDOS = V_AF_CPOPRO_CDPRO;

      IF V_CDPRODUTO IS NOT NULL THEN
         SELECT
            MAX(CDFILIAL)
         INTO
            V_CDFILIAL
         FROM FILIAL
         WHERE
            CDFILIAL = V_AF_CADFIL_CDFIL;
         IF V_CDFILIAL IS NOT NULL THEN
            SELECT
               DECODE(MAX(PARCMPSUP.IDTIPEMITGER), 1, MAX(FILIAL.CDEMPRESA), MAX(PARCMPSUP.CDEMPRESA)) CDEMPRESA,
               MAX(PARCMPSUP.IDTIPEMITGER)
            INTO
               V_CDEMPRESA,
               V_IDTIPEMITGER
            FROM
               PARCMPSUP, FILIAL
            WHERE
               FILIAL.CDFILIAL    = PARCMPSUP.CDFILIAL AND
               PARCMPSUP.CDFILIAL = V_AF_CADFIL_CDFIL;
            IF V_CDEMPRESA IS NOT NULL THEN
               SELECT
                  MAX(CDFORNECED),
                  MAX(IDTPIJURFORN),
                  MAX(NRINSJURFORN)
               INTO
                  V_CDFORNECED,
                  V_IDTPIJURFORN,
                  V_NRINSJURFORN
               FROM
                  FORNECEDOR
               WHERE
                  NRINSJURFORN LIKE '%'||V_AF_CADFOR_NRCGC;
               IF V_CDFORNECED IS NOT NULL THEN
                  SELECT
                     MAX(CDPRODUTO)
                  INTO
                     V_EXIST_PROD
                  FROM
                     PRODUTO
                  WHERE
                     CDPRODUTO = V_CDPRODUTO;
                  IF V_EXIST_PROD IS NOT NULL THEN
                     SELECT
                        MAX(AUTOFORNE.NRAUTOFORN)
                     INTO
                        V_NRAUTOFORN
                     FROM
                        ITEMAUTF,
                        AUTOFORNE
                     WHERE
                        AUTOFORNE.CDFILDEST  = V_AF_CADFIL_CDFIL AND
                        AUTOFORNE.CDFILLANC  = P_CDFILLANC AND
                        AUTOFORNE.CDFORNECED = V_CDFORNECED AND
                        AUTOFORNE.CDFILDEST  = ITEMAUTF.CDFILDEST  AND
                        AUTOFORNE.CDFILLANC  = ITEMAUTF.CDFILLANC  AND
                        AUTOFORNE.NRAUTOFORN = ITEMAUTF.NRAUTOFORN AND
                        ITEMAUTF.CDMARCA     = '99999' AND
                        ITEMAUTF.CDPRODUTO   = V_CDPRODUTO AND
                        ITEMAUTF.DTPROGENTAF = V_AF_SOLITE_DTENT;
                     IF V_NRAUTOFORN IS NULL THEN
                        IF (NVL(V_ANT_CDFORNECED, ' ') <> V_CDFORNECED)      OR
                           (NVL(V_ANT_CDFILDEST,  ' ') <> V_AF_CADFIL_CDFIL) OR
                           (NVL(V_ANT_CDPED, 0.1)      <> V_AF_PEDIDO_CDPED) THEN
                           V_ANT_CDFORNECED := V_CDFORNECED;
                           V_ANT_CDFILDEST  := V_AF_CADFIL_CDFIL;
                           V_ANT_CDPED      := V_AF_PEDIDO_CDPED;
                           NOVO_CODIGO('AUTOFORNE'||V_AF_CADFIL_CDFIL||P_CDFILLANC, V_CODIGO, 1);
                           V_CODIGO := SUBSTR(V_CODIGO, 11, 10);
                           IF V_LISTA IS NULL THEN
                              NOVO_CODIGO('LISTA', V_LISTA, 1);
                              V_LISTA := SUBSTR(V_LISTA, 11, 10);
                           END IF;

                           INSERT INTO LISTA (NRLISTA, CDLISTA)
                           VALUES(V_LISTA, V_AF_CADFIL_CDFIL||P_CDFILLANC||V_CODIGO);

                           INSERT INTO AUTOFORNE
                              (CDFILDEST, CDFILLANC, NRAUTOFORN, CDOPERADOR,
                               IDTIPOEMITAF, CDEMPRESA, CDFORNECED, DTAUTOFORN)
                           VALUES
                              (V_AF_CADFIL_CDFIL, P_CDFILLANC, V_CODIGO,
                               '000000000999', V_IDTIPEMITGER, V_CDEMPRESA,
                               V_CDFORNECED, V_AF_SOLFIL_DTREF);
                           IF V_AF_PEDIDO_CDPED IS NOT NULL THEN
                              INSERT INTO MENSAUTF
                                 (CDFILDEST, CDFILLANC, NRAUTOFORN,
                                  NRMENSAUTFOR,DSMENSAF)
                              VALUES
                                 (V_AF_CADFIL_CDFIL, P_CDFILLANC, V_CODIGO,
                                  '00', V_AF_PEDIDO_CDPED);
                           END IF;
                           INSERT INTO MENSAUTF
                              (CDFILDEST, CDFILLANC, NRAUTOFORN,
                               NRMENSAUTFOR,DSMENSAF)
                           VALUES
                              (V_AF_CADFIL_CDFIL, P_CDFILLANC, V_CODIGO,
                               '01', 'COMPRA CENTRALIZADA');
                        END IF;
                        INSERT INTO ITEMAUTF
                           (CDFILDEST, CDFILLANC, NRAUTOFORN,
                            CDPRODUTO, CDMARCA, DTPROGENTAF,
                            VRPREUNIAF, QTPROGENTAF, NRPARCITMAF, IDTPLANITEAF)
                        VALUES
                           (V_AF_CADFIL_CDFIL, P_CDFILLANC, V_CODIGO,
                            V_CDPRODUTO, '99999', V_AF_SOLITE_DTENT,
                            V_AF_SOLITE_VLPCO, V_AF_SOLITE_QTSOL, '00', 'A');

                        INSERT INTO MOVOPAF
                           (CDFILDESMOV, CDFILLANMOV, NRAUTOMOV, CDPRODMOV,
                            CDMARCMOV, DTPROGENTMOV, DTOPERAF, DSALTERAF, DSJUSTOPERMOV)
                        VALUES
                           (V_AF_CADFIL_CDFIL, P_CDFILLANC, V_CODIGO,
                            V_CDPRODUTO, '99999', V_AF_SOLITE_DTENT, SYSDATE,
                            'PRODUTO IMPORTADO', '');

                        UPDATE CMPPROD.ITEMAF_SACA2B@SDXLOGIS
                           SET CDIMPORTAF = 'P',
                               DTIMPORTAF = SYSDATE
                           WHERE SOLFIL_IDSOL = V_AF_SOLFIL_IDSOL AND
                                 PEDIDO_CDPED = V_AF_PEDIDO_CDPED AND
                                 CPOPRO_CDPRO = V_AF_CPOPRO_CDPRO AND
                                 SOLITE_DTENT = V_AF_SOLITE_DTENT;
                        IF SQL%ROWCOUNT = 0 THEN
                           INSERT INTO CMPPROD.ITEMAF_SACA2B@SDXLOGIS
                              (SOLFIL_IDSOL, PEDIDO_CDPED, CPOPRO_CDPRO, SOLITE_DTENT,
                               CDIMPORTAF, OBSIMPORTAF, DTIMPORTAF, USUSACAF, DTSACAF)
                           VALUES
                              (V_AF_SOLFIL_IDSOL, V_AF_PEDIDO_CDPED, V_AF_CPOPRO_CDPRO,
                               V_AF_SOLITE_DTENT, 'P', '', SYSDATE, '', '');
                        END IF;
                     ELSE
                        IF P_ATUALIZAR = 'S' THEN
                           UPDATE ITEMAUTF
                           SET VRPREUNIAF  = V_AF_SOLITE_VLPCO,
                               QTPROGENTAF = V_AF_SOLITE_QTSOL
                           WHERE CDFILDEST   = V_AF_CADFIL_CDFIL AND
                                 CDFILLANC   = P_CDFILLANC AND
                                 NRAUTOFORN  = V_NRAUTOFORN AND
                                 CDPRODUTO   = V_CDPRODUTO AND
                                 CDMARCA     = '99999' AND
                                 DTPROGENTAF = V_AF_SOLITE_DTENT;

                           INSERT INTO MOVOPAF
                              (CDFILDESMOV, CDFILLANMOV, NRAUTOMOV, CDPRODMOV,
                               CDMARCMOV, DTPROGENTMOV, DTOPERAF, DSALTERAF, DSJUSTOPERMOV)
                           VALUES
                              (V_AF_CADFIL_CDFIL, P_CDFILLANC, V_NRAUTOFORN,
                               V_CDPRODUTO, '99999', V_AF_SOLITE_DTENT, SYSDATE,
                               'PRODUTO IMPORTADO', '');

                           UPDATE CMPPROD.ITEMAF_SACA2B@SDXLOGIS
                           SET CDIMPORTAF = 'P',
                               DTIMPORTAF = SYSDATE
                           WHERE SOLFIL_IDSOL = V_AF_SOLFIL_IDSOL AND
                                 PEDIDO_CDPED = V_AF_PEDIDO_CDPED AND
                                 CPOPRO_CDPRO = V_AF_CPOPRO_CDPRO AND
                                 SOLITE_DTENT = V_AF_SOLITE_DTENT;
                           IF SQL%ROWCOUNT = 0 THEN
                              INSERT INTO CMPPROD.ITEMAF_SACA2B@SDXLOGIS
                                 (SOLFIL_IDSOL, PEDIDO_CDPED, CPOPRO_CDPRO, SOLITE_DTENT,
                                  CDIMPORTAF, OBSIMPORTAF, DTIMPORTAF, USUSACAF, DTSACAF)
                              VALUES
                                 (V_AF_SOLFIL_IDSOL, V_AF_PEDIDO_CDPED, V_AF_CPOPRO_CDPRO,
                                  V_AF_SOLITE_DTENT, 'P', '', SYSDATE, '', '');
                           END IF;
                        ELSE
                           INSERT INTO MOVOPAF
                              (CDFILDESMOV, CDFILLANMOV, NRAUTOMOV, CDPRODMOV,
                               CDMARCMOV, DTPROGENTMOV, DTOPERAF, DSALTERAF, DSJUSTOPERMOV)
                           VALUES
                              (V_AF_CADFIL_CDFIL, P_CDFILLANC, V_NRAUTOFORN,
                               V_CDPRODUTO, '99999', V_AF_SOLITE_DTENT, SYSDATE,
                               'PRODUTO NO IMPORTADO', 'ITEM AF J CADASTRADA');

                           UPDATE CMPPROD.ITEMAF_SACA2B@SDXLOGIS
                           SET OBSIMPORTAF = 'ITEM AF J CADASTRADA',
                               CDIMPORTAF = 'N',
                               DTIMPORTAF = SYSDATE
                           WHERE SOLFIL_IDSOL = V_AF_SOLFIL_IDSOL AND
                                 PEDIDO_CDPED = V_AF_PEDIDO_CDPED AND
                                 CPOPRO_CDPRO = V_AF_CPOPRO_CDPRO AND
                                 SOLITE_DTENT = V_AF_SOLITE_DTENT;
                           IF SQL%ROWCOUNT = 0 THEN
                              INSERT INTO CMPPROD.ITEMAF_SACA2B@SDXLOGIS
                                 (SOLFIL_IDSOL, PEDIDO_CDPED, CPOPRO_CDPRO, SOLITE_DTENT,
                                  CDIMPORTAF, OBSIMPORTAF, DTIMPORTAF, USUSACAF, DTSACAF)
                              VALUES
                                 (V_AF_SOLFIL_IDSOL, V_AF_PEDIDO_CDPED, V_AF_CPOPRO_CDPRO,
                                  V_AF_SOLITE_DTENT, 'N', 'ITEM AF J CADASTRADA', SYSDATE, '', '');
                           END IF;
                        END IF;
                     END IF;
                  ELSE
                     INSERT INTO MOVOPAF
                        (CDFILDESMOV, CDFILLANMOV, NRAUTOMOV, CDPRODMOV,
                         CDMARCMOV, DTPROGENTMOV, DTOPERAF, DSALTERAF, DSJUSTOPERMOV)
                     VALUES
                        (V_AF_CADFIL_CDFIL, P_CDFILLANC, V_AF_PEDIDO_CDPED,
                         V_CDPRODUTO, '99999', V_AF_SOLITE_DTENT, SYSDATE,
                         'PRODUTO NO IMPORTADO', 'PRODUTO '||V_AF_CPOPRO_CDPRO||' NO CADASTRADO');

                     UPDATE CMPPROD.ITEMAF_SACA2B@SDXLOGIS
                     SET OBSIMPORTAF = 'PRODUTO NO CADASTRADO',
                         CDIMPORTAF = 'N',
                         DTIMPORTAF = SYSDATE
                     WHERE SOLFIL_IDSOL = V_AF_SOLFIL_IDSOL AND
                           PEDIDO_CDPED = V_AF_PEDIDO_CDPED AND
                           CPOPRO_CDPRO = V_AF_CPOPRO_CDPRO AND
                           SOLITE_DTENT = V_AF_SOLITE_DTENT;

                     IF SQL%ROWCOUNT = 0 THEN
                        INSERT INTO CMPPROD.ITEMAF_SACA2B@SDXLOGIS
                           (SOLFIL_IDSOL, PEDIDO_CDPED, CPOPRO_CDPRO, SOLITE_DTENT,
                            CDIMPORTAF, OBSIMPORTAF, DTIMPORTAF, USUSACAF, DTSACAF)
                        VALUES
                           (V_AF_SOLFIL_IDSOL, V_AF_PEDIDO_CDPED, V_AF_CPOPRO_CDPRO,
                            V_AF_SOLITE_DTENT, 'N', 'PRODUTO NO CADASTRADO', SYSDATE, '', '');
                     END IF;
                  END IF;
               ELSE
                  INSERT INTO MOVOPAF
                     (CDFILDESMOV, CDFILLANMOV, NRAUTOMOV, CDPRODMOV,
                      CDMARCMOV, DTPROGENTMOV, DTOPERAF, DSALTERAF, DSJUSTOPERMOV)
                  VALUES
                     (V_AF_CADFIL_CDFIL, P_CDFILLANC, V_AF_PEDIDO_CDPED,
                      V_CDPRODUTO, '99999', V_AF_SOLITE_DTENT, SYSDATE,
                      'PRODUTO NO IMPORTADO', 'FORNECEDOR '||V_AF_CADFOR_NRCGC||' NAO CADASTRADO');

                  UPDATE CMPPROD.ITEMAF_SACA2B@SDXLOGIS
                  SET OBSIMPORTAF = 'FORNECEDOR NO CADASTRADO',
                      CDIMPORTAF = 'N',
                      DTIMPORTAF = SYSDATE
                  WHERE SOLFIL_IDSOL = V_AF_SOLFIL_IDSOL AND
                        PEDIDO_CDPED = V_AF_PEDIDO_CDPED AND
                        CPOPRO_CDPRO = V_AF_CPOPRO_CDPRO AND
                        SOLITE_DTENT = V_AF_SOLITE_DTENT;

                  IF SQL%ROWCOUNT = 0 THEN
                     INSERT INTO CMPPROD.ITEMAF_SACA2B@SDXLOGIS
                        (SOLFIL_IDSOL, PEDIDO_CDPED, CPOPRO_CDPRO, SOLITE_DTENT,
                         CDIMPORTAF, OBSIMPORTAF, DTIMPORTAF, USUSACAF, DTSACAF)
                     VALUES
                        (V_AF_SOLFIL_IDSOL, V_AF_PEDIDO_CDPED, V_AF_CPOPRO_CDPRO,
                         V_AF_SOLITE_DTENT, 'N', 'FORNECEDOR NO CADASTRADO', SYSDATE, '', '');
                  END IF;
               END IF;
            ELSE
               INSERT INTO MOVOPAF
                  (CDFILDESMOV, CDFILLANMOV, NRAUTOMOV, CDPRODMOV,
                   CDMARCMOV, DTPROGENTMOV, DTOPERAF, DSALTERAF, DSJUSTOPERMOV)
               VALUES
                  (V_AF_CADFIL_CDFIL, P_CDFILLANC, V_AF_PEDIDO_CDPED,
                   V_CDPRODUTO, '99999', V_AF_SOLITE_DTENT, SYSDATE,
                   'PRODUTO NO IMPORTADO', 'EMPRESA NO CADASTRADA');

               UPDATE CMPPROD.ITEMAF_SACA2B@SDXLOGIS
               SET OBSIMPORTAF = 'EMPRESA NO CADASTRADA',
                   CDIMPORTAF = 'N',
                   DTIMPORTAF = SYSDATE
               WHERE SOLFIL_IDSOL = V_AF_SOLFIL_IDSOL AND
                     PEDIDO_CDPED = V_AF_PEDIDO_CDPED AND
                     CPOPRO_CDPRO = V_AF_CPOPRO_CDPRO AND
                     SOLITE_DTENT = V_AF_SOLITE_DTENT;

               IF SQL%ROWCOUNT = 0 THEN
                  INSERT INTO CMPPROD.ITEMAF_SACA2B@SDXLOGIS
                     (SOLFIL_IDSOL, PEDIDO_CDPED, CPOPRO_CDPRO, SOLITE_DTENT,
                      CDIMPORTAF, OBSIMPORTAF, DTIMPORTAF, USUSACAF, DTSACAF)
                  VALUES
                     (V_AF_SOLFIL_IDSOL, V_AF_PEDIDO_CDPED, V_AF_CPOPRO_CDPRO,
                      V_AF_SOLITE_DTENT, 'N', 'EMPRESA NO CADASTRADA', SYSDATE, '', '');

               END IF;
            END IF;
         ELSE
            INSERT INTO MOVOPAF
               (CDFILDESMOV, CDFILLANMOV, NRAUTOMOV, CDPRODMOV,
                CDMARCMOV, DTPROGENTMOV, DTOPERAF, DSALTERAF, DSJUSTOPERMOV)
            VALUES
               (V_AF_CADFIL_CDFIL, P_CDFILLANC, V_AF_PEDIDO_CDPED,
                V_CDPRODUTO, '99999', V_AF_SOLITE_DTENT, SYSDATE,
                'PRODUTO NO IMPORTADO', 'FILIAL NO CADASTRADA');

            UPDATE CMPPROD.ITEMAF_SACA2B@SDXLOGIS
            SET OBSIMPORTAF = 'FILIAL NO CADASTRADA',
                CDIMPORTAF = 'N',
                DTIMPORTAF = SYSDATE
            WHERE SOLFIL_IDSOL = V_AF_SOLFIL_IDSOL AND
                  PEDIDO_CDPED = V_AF_PEDIDO_CDPED AND
                  CPOPRO_CDPRO = V_AF_CPOPRO_CDPRO AND
                  SOLITE_DTENT = V_AF_SOLITE_DTENT;

            IF SQL%ROWCOUNT = 0 THEN
               INSERT INTO CMPPROD.ITEMAF_SACA2B@SDXLOGIS
                  (SOLFIL_IDSOL, PEDIDO_CDPED, CPOPRO_CDPRO, SOLITE_DTENT,
                   CDIMPORTAF, OBSIMPORTAF, DTIMPORTAF, USUSACAF, DTSACAF)
               VALUES
                  (V_AF_SOLFIL_IDSOL, V_AF_PEDIDO_CDPED, V_AF_CPOPRO_CDPRO,
                   V_AF_SOLITE_DTENT, 'N', 'FILIAL NO CADASTRADA', SYSDATE, '', '');
            END IF;
         END IF;
      ELSE
         INSERT INTO MOVOPAF
            (CDFILDESMOV, CDFILLANMOV, NRAUTOMOV, CDPRODMOV,
             CDMARCMOV, DTPROGENTMOV, DTOPERAF, DSALTERAF, DSJUSTOPERMOV)
         VALUES
            (V_AF_CADFIL_CDFIL, P_CDFILLANC, V_AF_PEDIDO_CDPED,
             V_AF_CPOPRO_CDPRO, '99999', V_AF_SOLITE_DTENT, SYSDATE,
             'PRODUTO NO IMPORTADO', 'RELAC. DE PRODUTO '||V_AF_CPOPRO_CDPRO||' NO CADASTRADO');

         UPDATE CMPPROD.ITEMAF_SACA2B@SDXLOGIS
         SET OBSIMPORTAF = 'RELACIONAMENTO DE INTEGRAO DO PRODUTO NO CADASTRADO',
             CDIMPORTAF = 'N',
             DTIMPORTAF = SYSDATE
         WHERE SOLFIL_IDSOL = V_AF_SOLFIL_IDSOL AND
               PEDIDO_CDPED = V_AF_PEDIDO_CDPED AND
               CPOPRO_CDPRO = V_AF_CPOPRO_CDPRO AND
               SOLITE_DTENT = V_AF_SOLITE_DTENT;

         IF SQL%ROWCOUNT = 0 THEN
            INSERT INTO CMPPROD.ITEMAF_SACA2B@SDXLOGIS
               (SOLFIL_IDSOL, PEDIDO_CDPED, CPOPRO_CDPRO, SOLITE_DTENT,
                CDIMPORTAF, OBSIMPORTAF, DTIMPORTAF, USUSACAF, DTSACAF)
            VALUES
               (V_AF_SOLFIL_IDSOL, V_AF_PEDIDO_CDPED, V_AF_CPOPRO_CDPRO,
                V_AF_SOLITE_DTENT, 'N', 'RELACIONAMENTO DE INTEGRAO DO PRODUTO NO CADASTRADO', SYSDATE, '', '');
         END IF;
      END IF;
   END LOOP;
   FOR C_FECHAMENTO IN
      (SELECT
          SUBSTR(CDLISTA, 1, 4)  CDFILDEST,
          SUBSTR(CDLISTA, 5, 4)  CDFILLANC,
          SUBSTR(CDLISTA, 9, 10) NRAUTOFORN
       FROM LISTA
       WHERE NRLISTA = V_LISTA
       )
   LOOP
      FECHAMENTO_AF(C_FECHAMENTO.CDFILDEST, C_FECHAMENTO.CDFILLANC, C_FECHAMENTO.NRAUTOFORN);
   END LOOP;
   DELETE FROM LISTA WHERE NRLISTA = V_LISTA;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('USR_IMPORTA_AF','5.07.002'); END;
/

