package com.javaseleniumtemplate.pages;

import com.javaseleniumtemplate.bases.PageBase;
import org.openqa.selenium.By;
import org.testng.Assert;

import java.util.ArrayList;
import java.util.List;

public class AcompanhamentoAprovCardPage extends PageBase {

    By botaoMenu = By.xpath("//div[@class='bars']");
    By campoPesquisar = By.xpath("//section[@class='zh-container-search-menu']//input[@type='text']");
    By opcaoTelaAcompanhamentoAprovCard = By.xpath("//span[text() = 'Acompanhamento de Aprovação de Cardápio']");
    By campoRelatorio = By.xpath("//div[@data-zh-id=\"10889986310572390481502\"]//div[@class=\"new-select input-text form-input-margin-bottom mousetrap form-control zh-text-align-{{field.align || 'left'}} ng-pristine ng-untouched ng-valid\"]");
    By relatorioAcompAprovCardapio = By.xpath("//div[@data-zh-id=\"10889986310572390481502\"]//li[text() = 'Acompanhamento de Aprovação de Cardápio']");

    By campoUnidade = By.id("NMFILIAL");
    By botaoTodasUnidades = By.xpath("//label[@for=\"zh-checkbox-ALLFILIAL\"]//div[@class=\"zh-box mousetrap zh-ripple-effect\"]");
    By inputCheckTodasUnidades = By.id("zh-checkbox-ALLFILIAL");
    By unidadeDepositoJabaquara = By.xpath("//div[@data-zh-field-name=\"NMFILIAL\"]//span[text() = 'DEPOSITO JABAQUARA']");
    By unidadeDepositoBc111 = By.xpath("//div[@data-zh-field-name=\"NMFILIAL\"]//span[text() = 'DEPOSITO BC 111']");

    By campoServico = By.id("NMSERVICO");
    By botaoTodosServicos = By.xpath("//label[@for=\"zh-checkbox-ALLSERVICO\"]//div[@class=\"zh-box mousetrap zh-ripple-effect\"]");
    By inputCheckTodosServicos = By.id("zh-checkbox-ALLSERVICO");
    By servicoJantar = By.xpath("//div[@data-zh-field-name=\"NMSERVICO\"]//span[text() = 'JANTAR']");
    By servicoAlmoco = By.xpath("//div[@data-zh-field-name=\"NMSERVICO\"]//span[text() = 'ALMOÇO']");

    By botaoOk = By.xpath("//section[@class=\"popup-container\"]//div[@class=\"zh-footer-right\"]");
    By botaoCardapioDe = By.xpath("//div[@id=\"MESINICIO\"]//span[@style=\"background-image: none; display: block;\"]");
    By campoCardapioDe = By.id("MESINICIO");
    By botaoCardapioAte = By.xpath("//div[@id=\"MESFINAL\"]//span[@style=\"background-image: none; display: block;\"]");
    By campoCardapioAte = By.id("MESFINAL");
    By mesMarco = By.xpath("//div[@class=\"calendar\"]//div[@class=\"month\"]//div[text() = 'Mar']");
    By mesOutubro = By.xpath("//div[@class=\"calendar\"]//div[@class=\"month\"]//div[text() = 'Out']");
    By anoCalendario = By.xpath("//section[@class=\"calendar month-picker zh-calendar-widget\"]//h3[@ng-bind=\"currentYear\"]");
    By setaVoltarAno = By.xpath("//section[@class=\"calendar month-picker zh-calendar-widget\"]//div[@class=\"arrow-left zh-icon zh-icon-previous zh-icon-no-border\"]");

    By mensagemObrigatorioUnidade = By.xpath("//div[@data-zh-id=\"1088998639863655421508\"]//div[@class=\"zh-validation\"]/span");
    By mensagemObrigatorioServico = By.xpath("//div[@data-zh-id=\"10889986329218575291515\"]//div[@class=\"zh-validation\"]/span");
    By mensagemObrigatorioCardapioDe = By.xpath("//div[@data-zh-id=\"108899863510268491522\"]//div[@class=\"zh-validation\"]/span");
    By mensagemObrigatorioCardapioAte = By.xpath("//div[@data-zh-id=\"10889986319842755061523\"]//div[@class=\"zh-validation\"]/span");

    By mensagemAlerta = By.xpath("//section[@class=\"zh-container-alert\"]//div[@class=\"zh-alert-scroll\"]/p");
    By botaoOkAlerta = By.xpath("//section[@class=\"zh-container-alert\"]//button[@class=\"zh-alert-button\"]");

    By tipoPdf = By.xpath("//label[@for='radio-QR2TYPE-PDF']//div[@contenteditable='true']");
    By botaoRelatorio = By.xpath("//div[@class='zh-footer-right']");
    By botaoConfirmar = By.xpath("//section[@id='popup']//span[text() = 'Confirmar']");

    public void acessarTela() {
        tempoParaAguardarTelaInicial();
        waitForElement(botaoMenu);
        click(botaoMenu);
        sendKeys(campoPesquisar, "Acompanhamento de Aprovação de Cardápio");
        click(opcaoTelaAcompanhamentoAprovCard);
    }

    public void selecionarRelatorio() {
        clicarCampoSelecionarValor(campoRelatorio, relatorioAcompAprovCardapio);
    }

    public void selecionarUnidades() {
        click(campoUnidade);
        click(unidadeDepositoJabaquara);
        click(unidadeDepositoBc111);
        click(botaoOk);
    }

    public void selecionarServicos() {
        click(botaoTodosServicos);
        click(campoServico);
        click(servicoJantar);
        click(servicoAlmoco);
        click(botaoOk);
    }

    public void selecionarMeses() {
        click(campoCardapioDe);
        int ano = Integer.parseInt(getText(anoCalendario));
        if (ano > 2023) {
            for (int x = 1; x <= ano - 2023; x++) {
                click(setaVoltarAno);
            }
        }
        click(mesMarco);

        click(campoCardapioAte);
        if (ano > 2023) {
            for (int x = 1; x <= ano - 2023; x++) {
                click(setaVoltarAno);
            }
        }
        click(mesOutubro);

        String mesInicial = getText(campoCardapioDe);
        String mesFinal = getText(campoCardapioAte);
        Assert.assertEquals(mesInicial, "03/2023", "Verificação do valor do campo 'cardápio de' após a seleção dos meses");
        Assert.assertEquals(mesFinal, "10/2023", "Verificação do valor do campo 'cardápio até' após a seleção dos meses");
    }

    public void geraRelatorio() {
        super.geraRelatorio(botaoRelatorio, tipoPdf, botaoConfirmar);
        fecharGuiaDoRelatorio();
    }

    private void fecharGuiaDoRelatorio() {
        tempo();
        tempo();
        tempo();
        String winHandleBefore = driver.getWindowHandle();
        List<String> aba = new ArrayList<>(driver.getWindowHandles());
        driver.switchTo().window(aba.get(1));
        driver.close();
        driver.switchTo().window(winHandleBefore);
    }

    public void selecionarTodasUnidadesEServicos() {
        click(botaoTodasUnidades);
        click(botaoTodosServicos);

        boolean todasUnidades = returnIfElementIsSelected(inputCheckTodasUnidades);
        boolean todosServicos = returnIfElementIsSelected(inputCheckTodosServicos);
        Assert.assertEquals(todasUnidades, true, "Verificação se após clicar no botão todas unidades, o mesmo está selecionado");
        Assert.assertEquals(todosServicos, true, "Verificação se após clicar no botão todos serviços, o mesmo está selecionado");
    }

    public void camposObrigatorios() {
        tempo();
        click(botaoTodosServicos);
        click(botaoCardapioDe);
        click(botaoCardapioAte);
        click(botaoRelatorio);

        String unidade = getText(mensagemObrigatorioUnidade);
        String servico = getText(mensagemObrigatorioServico);
        String cardapioDe = getText(mensagemObrigatorioCardapioDe);
        String cardapioAte = getText(mensagemObrigatorioCardapioAte);

        String mensagemEsperada = "Campo obrigatório";
        Assert.assertEquals(unidade, mensagemEsperada, "Verificação da mensagem de 'campo obrigatório', no campo unidade");
        Assert.assertEquals(servico, mensagemEsperada, "Verificação da mensagem de 'campo obrigatório', no campo serviço");
        Assert.assertEquals(cardapioDe, mensagemEsperada, "Verificação da mensagem de 'campo obrigatório', no campo cardápio de");
        Assert.assertEquals(cardapioAte, mensagemEsperada, "Verificação da mensagem de 'campo obrigatório', no campo cardápio até");
    }

    public void mesFinalMaiorQueInicial() {
        clicarCampoSelecionarValor(campoCardapioDe, mesOutubro);
        clicarCampoSelecionarValor(campoCardapioAte, mesMarco);
        click(botaoRelatorio);

        String mensagem = getText(mensagemAlerta);
        String mensagemEsperada = "O campo \"Cardápio de\" deve ser menor ou igual ao campo \"Até\"";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificação da mensagem exibida na tela quando tenta gerar um relatório com o mês inicial sendo maior que o final");
        click(botaoOkAlerta);
    }

    public void interacaoCheckBox() {
        boolean unidade = returnIfElementIsSelected(inputCheckTodasUnidades);
        boolean servico = returnIfElementIsSelected(inputCheckTodosServicos);
        boolean campoUnidades = Boolean.parseBoolean(javaScriptExecutor.executeScript("return document.querySelector(\"#NMFILIAL\").isContentEditable").toString());
        boolean campoServicos = Boolean.parseBoolean(javaScriptExecutor.executeScript("return document.querySelector(\"#NMSERVICO\").isContentEditable").toString());
        Assert.assertEquals(unidade, false, "Verificação se check-box de todas as unidades não está selecionado");
        Assert.assertEquals(campoUnidades, true, "Verificação se com o check-box de todas as unidades não selecionado, o campo unidades está habilitado");
        Assert.assertEquals(servico, true, "Verificação se o check-box de todos os serviços está selecionado");
        Assert.assertEquals(campoServicos, false, "Verificação se com o check-box de todos os serviços selecionado, o campo serços está desabilitado");

        click(botaoTodasUnidades);
        click(botaoTodosServicos);

        unidade = returnIfElementIsSelected(inputCheckTodasUnidades);
        servico = returnIfElementIsSelected(inputCheckTodosServicos);
        campoUnidades = Boolean.parseBoolean(javaScriptExecutor.executeScript("return document.querySelector(\"#NMFILIAL\").isContentEditable").toString());
        campoServicos = Boolean.parseBoolean(javaScriptExecutor.executeScript("return document.querySelector(\"#NMSERVICO\").isContentEditable").toString());
        Assert.assertEquals(unidade, true, "Verificação se check-box de todas as unidades está selecionado");
        Assert.assertEquals(campoUnidades, false, "Verificação se com o check-box de todas as unidades selecionado, o campo unidades está desabilitado");
        Assert.assertEquals(servico, false, "Verificação se o check-box de todos os serviços não está selecionado");
        Assert.assertEquals(campoServicos, true, "Verificação se com o check-box de todos os serviços não selecionado, o campo serviços está habilitado");
    }

}
