package com.javaseleniumtemplate.pages;

import com.javaseleniumtemplate.bases.PageBase;
import org.openqa.selenium.By;
import org.testng.Assert;

import java.util.ArrayList;
import java.util.List;

public class AnaliseRequisicaoProjecaoPage extends PageBase {

    By botaoMenu = By.xpath("//div[@class='bars']");
    By campoPesquisar = By.xpath("//section[@class='zh-container-search-menu']//input[@type='text']");
    By telaAnaliseRequisicaoProjecao = By.xpath("//span[text() = 'Análise de Requisição Projeção']");

    By campoRelatorio = By.xpath("//div[@data-zh-id=\"7994725533996569715576\"]//div[@class=\"new-select input-text form-input-margin-bottom mousetrap form-control zh-text-align-{{field.align || 'left'}} ng-pristine ng-untouched ng-valid\"]");
    By relatorioAnaliseRequisicaoProjecao = By.xpath("//div[@data-zh-id=\"7994725533996569715576\"]//li[text() = 'Análise de Requisição - Projeção']");
    By campoUnidade = By.id("NMFILIAL");
    By unidadeDepositoBc129 = By.xpath("//div[@data-zh-id=\"7994725510712161375578\"]//span[text() = '9999 | DEPOSITO BC 129']");

    By campoProcurar = By.xpath("//div[@class=\"floating-card-input\"]//input[@placeholder=\"Procurar\"]");
    By botaoCampoDataLevantamento = By.xpath("//div[@id=\"DTINTERVAL\"]//span[@style=\"background-image: none; display: block;\"][2]");
    By botaoCampoProdutoInicial = By.xpath("//div[@id=\"NMPRODUTOINI\"]//span[@style=\"background-image: none; display: block;\"]");
    By botaoCampoProdutoFinal = By.xpath("//div[@id=\"NMPRODUTOFIN\"]//span[@style=\"background-image: none; display: block;\"]");
    By botaoCampoTipoCusto = By.xpath("//div[@id=\"NMTIPOCUSTO\"]//span[@style=\"background-image: none; display: block;\"]");
    By botaoPesquisar = By.xpath("//div[@class=\"control-menu\"]//li[@data-zh-id=\"zh-floating-control-custom-action-1\"]");
    By botaoOkAlerta = By.xpath("//section[@class=\"zh-container-alert\"]//button");

    By checkBoxConsiderarRequisicao = By.xpath("//label[@for=\"zh-checkbox-P_CONSSOL\"]//div[@class=\"zh-box mousetrap zh-ripple-effect\"]");
    By checkBoxConsiderarEstoque = By.xpath("//label[@for=\"zh-checkbox-P_CONSEST\"]//div[@class=\"zh-box mousetrap zh-ripple-effect\"]");
    By checkBoxConsiderarAF = By.xpath("//label[@for=\"zh-checkbox-P_CONSAF\"]//div[@class=\"zh-box mousetrap zh-ripple-effect\"]");
    By checkBoxGerarSolicitacao = By.xpath("//label[@for=\"zh-checkbox-P_IDGERSOL\"]//div[@class=\"zh-box mousetrap zh-ripple-effect\"]");
    By inputConsiderarRequisicao = By.id("zh-checkbox-P_CONSSOL");
    By inputConsiderarEstoque = By.id("zh-checkbox-P_CONSEST");
    By inputConsiderarAF = By.id("zh-checkbox-P_CONSAF");
    By inputGerarSolicitacao = By.id("zh-checkbox-P_IDGERSOL");

    By campoDataInicial = By.id("DTINTERVAL_START");
    By campoDataFinal = By.id("DTINTERVAL_END");
    By campoTipoCusto = By.id("NMTIPOCUSTO");
    By tipoCustoMedioBrutoAtual = By.xpath("//div[@data-zh-id=\"7994725541443189005594\"]//div[@class=\"list-items show-select\"]//span[text() = 'Custo Médio Bruto Atual']");
    By valorCampoTipoCusto = By.xpath("//div[@id=\"NMTIPOCUSTO\"]//span[@class=\"value\"]");

    By produtoCreosoto = By.xpath("//div[@data-zh-field-name=\"NMPRODUTO\"]//span[text() = 'CREOSOTO']");
    By produtoPeneiraArroz = By.xpath("//div[@data-zh-field-name=\"NMPRODUTO\"]//span[text() = 'PENEIRA ARROZ 55 CM INOX VITORIA']");

    By botaoRelatorio = By.xpath("//div[@class='zh-footer-right']");
    By tipoPdf = By.xpath("//label[@for='radio-QR2TYPE-PDF']//div[@class='zh-inner-circle']");
    By botaoConfirmar = By.xpath("//section[@id='popup']//div[@class='zh-footer-right']//span[text() = 'Confirmar']");

    By mensagemAlerta = By.xpath("//section[@class=\"zh-container-alert\"]//p[@class=\"zh-text-alert\"]");
    By mensagemObrigatorioUnidade = By.xpath("//div[@data-zh-id=\"7994725510712161375578\"]//div[@class=\"zh-validation\"]/span");
    By mensagemObrigatorioDataLevantamento = By.xpath("//div[@data-zh-id=\"7994725526189947305585\"]//div[@class=\"zh-validation\"]/span");
    By mensagemObrigatorioProdutoInicial = By.xpath("//div[@data-zh-id=\"7994725518222077785587\"]//div[@class=\"zh-validation\"]/span");
    By mensagemObrigatorioProdutoFinal = By.xpath("//div[@data-zh-id=\"7994725539107158315590\"]//div[@class=\"zh-validation\"]/span");
    By mensagemObrigatorioTipoCusto = By.xpath("//div[@data-zh-id=\"7994725541443189005594\"]//div[@class=\"zh-validation\"]/span");

    public void acessarTela() {
        tempoParaAguardarTelaInicial();
        waitForElement(botaoMenu);
        click(botaoMenu);
        sendKeys(campoPesquisar, "Análise de Requisição Projeção");
        click(telaAnaliseRequisicaoProjecao);
    }

    public void selecionarRelatorio() {
        clicarCampoSelecionarValor(campoRelatorio, relatorioAnaliseRequisicaoProjecao);
    }

    public void selecionarUnidade() {
        clicarCampoSelecionarValor(campoUnidade, unidadeDepositoBc129);
    }

    public void preencherDatas(String dataInicial, String dataFinal) {
        super.preencherDatas(campoDataInicial, campoDataFinal, dataInicial, dataFinal);
    }

    public void selecionarProdutos() {
        click(botaoCampoProdutoInicial);
        tempo();
        if (!driver.findElement(botaoPesquisar).getAttribute("className").contains("opened")) click(botaoPesquisar);
        sendKeys(campoProcurar, "101110100100");
        click(produtoCreosoto);

        click(botaoCampoProdutoFinal);
        tempo();
        if (!driver.findElement(botaoPesquisar).getAttribute("className").contains("opened")) click(botaoPesquisar);
        sendKeys(campoProcurar, "705310100100");
        click(produtoPeneiraArroz);
    }

    public void selecionarTipoCusto() {
        clicarCampoSelecionarValor(campoTipoCusto, tipoCustoMedioBrutoAtual);
        String tipoCusto = getText(valorCampoTipoCusto);
        Assert.assertEquals(tipoCusto, "Custo Médio Bruto Atual", "Verificar o valor apresentado no campo tipo de custo, após selecionar o tipo de custo desejado");
    }

    public void selecionarGerarSolicitacaoCompras() {
        click(checkBoxGerarSolicitacao);
        boolean gerarSolicitacao = returnIfElementIsSelected(inputGerarSolicitacao);
        Assert.assertTrue(gerarSolicitacao, "Verificar se o check-box de gerar solicitação de compras, está selecionado após clicar no mesmo");
    }

    public void camposObrigatorios() {
        click(botaoCampoDataLevantamento);
        click(botaoCampoTipoCusto);
        click(botaoRelatorio);

        String mensagem = getText(mensagemAlerta);
        String mensagemEsperada = "Preencha os campos obrigatórios!";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificar mensagem exibida na tela informando que os campos obrigatórios devem ser preenchidos");
        click(botaoOkAlerta);

        String unidade = getText(mensagemObrigatorioUnidade);
        String dataLevantamento = getText(mensagemObrigatorioDataLevantamento);
        String produtoInicial = getText(mensagemObrigatorioProdutoInicial);
        String produtoFinal = getText(mensagemObrigatorioProdutoFinal);
        String tipoCusto = getText(mensagemObrigatorioTipoCusto);

        mensagemEsperada = "Campo obrigatório";
        Assert.assertEquals(unidade, mensagemEsperada, "Verificar mensagem de campo obrigatório no campo 'unidade'");
        Assert.assertEquals(dataLevantamento, "Campo obrigatório!", "Verificar mensagem de campo obrigatório no campo 'data de levantamento'");
        Assert.assertEquals(produtoInicial, mensagemEsperada, "Verificar mensagem de campo obrigatório no campo 'produto inicial'");
        Assert.assertEquals(produtoFinal, mensagemEsperada, "Verificar mensagem de campo obrigatório no campo 'produto final'");
        Assert.assertEquals(tipoCusto, mensagemEsperada, "Verificar mensagem de campo obrigatório no campo 'tipo de custo'");
    }

    public void obrigatorioConsiderar() {
        click(checkBoxConsiderarRequisicao);
        click(checkBoxConsiderarEstoque);
        click(checkBoxConsiderarAF);
        click(botaoRelatorio);

        String mensagem = getText(mensagemAlerta);
        String mensagemEsperada = "\"Considerar\" deve ser informado";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificar mensagem exibida na tela ao tentar gerar o relatório sem ao menos 1 considerar selecionado");
        click(botaoOkAlerta);
    }

    public void considerar(String considerar) {
        tempo();
        if (returnIfElementIsSelected(inputConsiderarRequisicao)) click(checkBoxConsiderarRequisicao);
        if (returnIfElementIsSelected(inputConsiderarEstoque)) click(checkBoxConsiderarEstoque);
        if (returnIfElementIsSelected(inputConsiderarAF)) click(checkBoxConsiderarAF);

        switch (considerar) {
            case "Requisição":
                click(checkBoxConsiderarRequisicao);
                break;
            case "Estoque":
                click(checkBoxConsiderarEstoque);
                break;
            case "AF":
                click(checkBoxConsiderarAF);
                break;
        }
    }

    public void geraRelatorio() {
        super.geraRelatorio(botaoRelatorio, tipoPdf, botaoConfirmar);
        fecharGuiaDoRelatorio();
    }

    private void fecharGuiaDoRelatorio() {
        tempo();
        tempo();
        String winHandleBefore = driver.getWindowHandle();
        List<String> aba = new ArrayList<>(driver.getWindowHandles());
        driver.switchTo().window(aba.get(1));
        driver.getCurrentUrl();
        driver.close();
        driver.switchTo().window(winHandleBefore);
    }

}