package com.javaseleniumtemplate.pages;

import com.javaseleniumtemplate.bases.PageBase;
import org.openqa.selenium.By;
import org.testng.Assert;

import java.util.ArrayList;
import java.util.List;

public class DiferencaComensaisCardPage extends PageBase {

    By botaoMenu = By.xpath("//div[@class='bars']");
    By campoPesquisar = By.xpath("//section[@class='zh-container-search-menu']//input[@type='text']");
    By opcaoTelaDiferencaComenCard = By.xpath("//span[text() = 'Diferença de Comensais no Cardápio']");

    By campoRelatorio = By.id("REPORT_NAME");
    By relatorioDiferencaAnalitico = By.xpath("//div[@data-zh-id=\"6747577712084634724803\"]//div[@class=\"list-items show-select\"]//span[text() = 'Diferença de Comensais no Cardápio (Analítico)']");
    By relatorioDiferencaSintetico = By.xpath("//div[@data-zh-id=\"6747577712084634724803\"]//div[@class=\"list-items show-select\"]//span[text() = 'Diferença de Comensais no Cardápio (Sintético)']");
    By botaoCampoRelatorio = By.xpath("//div[@id=\"REPORT_NAME\"]//span[@style=\"background-image: none; display: block;\"]");

    By campoAgrupamentoUnidades = By.id("NMGRUPFILI");
    By agrupamentoMateriaPrima = By.xpath("//div[@data-zh-id=\"67475777117056823444806\"]//span[text() = '0000000002 | MATERIA PRIMA - MATERIAL DE EMBALAGEM']");

    By todasUnidades = By.xpath("//div[@data-zh-id=\"6747577719814603904816\"]//div[@class=\"zh-box mousetrap zh-ripple-effect\"]");
    By campoUnidades = By.id("NMFILIAL");
    By unidadeDepositoJabaquara = By.xpath("//div[@data-zh-field-name=\"NMFILIAL\"]//span[text() = 'DEPOSITO JABAQUARA']");
    By unidadeDepositoBc129 = By.xpath("//div[@data-zh-field-name=\"NMFILIAL\"]//span[text() = 'DEPOSITO BC 129']");

    By todosServicos = By.xpath("//div[@data-zh-id=\"6747577713022994364823\"]//div[@class=\"zh-box mousetrap zh-ripple-effect\"]");
    By campoServico = By.id("NMSERVICO");
    By servicoJantar = By.xpath("//div[@data-zh-field-name=\"NMSERVICO\"]//span[text() = 'JANTAR']");
    By servicoRetiradas = By.xpath("//div[@data-zh-field-name=\"NMSERVICO\"]//span[text() = 'RETIRADAS']");
    By servicoJanta = By.xpath("//div[@data-zh-field-name=\"NMSERVICO\"]//span[text() = 'JANTA']");

    By botaoOk = By.xpath("//section[@class=\"popup-container\"]//div[@class=\"zh-footer-right\"]");
    By campoMesInicial = By.id("MESINICIO");
    By botaoMesInicinal = By.xpath("//div[@id=\"MESINICIO\"]//span[@style=\"background-image: none; display: block;\"]");
    By campoMesFinal = By.id("MESFINAL");
    By botaoMesFinal = By.xpath("//div[@id=\"MESFINAL\"]//span[@style=\"background-image: none; display: block;\"]");
    By mesMaio = By.xpath("//div[@class=\"calendar\"]//div[text() = 'Mai']");
    By mesJulho = By.xpath("//div[@class=\"calendar\"]//div[text() = 'Jul']");

    By botaoRelatorio = By.xpath("//div[@class=\"zh-footer-right\"]");
    By tipoPdf = By.xpath("//label[@for=\"radio-QR2TYPE-PDF\"]//div[@class=\"zh-circle mousetrap zh-ripple-effect\"]");
    By botaoConfirmar = By.xpath("//section[@class=\"popup-container\"]//div[@class=\"zh-footer-right\"]");

    By campoMensagemAlerta = By.xpath("//section[@class=\"zh-container-alert\"]//p[@class=\"zh-text-alert\"]");
    By botaoOkAlerta = By.xpath("//section[@class=\"zh-container-alert\"]//button[@class=\"zh-alert-button\"]");

    By mensagemObrigatorioRelatorio = By.xpath("//div[@data-zh-id=\"6747577712084634724803\"]//div[@class=\"zh-validation\"]/span");
    By mensagemObrigatorioUnidade = By.xpath("//div[@data-zh-id=\"67475777134810700014811\"]//div[@class=\"zh-validation\"]/span");
    By mensagemObrigatorioServico = By.xpath("//div[@data-zh-id=\"67475777119757611614818\"]//div[@class=\"zh-validation\"]/span");
    By mensagemObrigatorioMesInicial = By.xpath("//div[@data-zh-id=\"67475777137065491014825\"]//div[@class=\"zh-validation\"]/span");
    By mensagemObrigatorioMesFinal = By.xpath("//div[@data-zh-id=\"67475777130399591754826\"]//div[@class=\"zh-validation\"]/span");

    public void acessarTela() {
        tempoParaAguardarTelaInicial();
        waitForElement(botaoMenu);
        click(botaoMenu);
        sendKeys(campoPesquisar, "Diferença de Comensais no Cardápio");
        click(opcaoTelaDiferencaComenCard);
    }

    public void selecionarRelatorio(String nomeRelatorio) {
        tempo();
        if (nomeRelatorio == "Diferença de Comensais no Cardápio (Analítico)") {
            clicarCampoSelecionarValor(campoRelatorio, relatorioDiferencaAnalitico);
        } else if (nomeRelatorio == "Diferença de Comensais no Cardápio (Sintético)") {
            clicarCampoSelecionarValor(campoRelatorio, relatorioDiferencaSintetico);
        }
    }

    public void selecionarAgrupamentoUnidade() {
        tempo();
        clicarCampoSelecionarValor(campoAgrupamentoUnidades, agrupamentoMateriaPrima);
    }

    public void selecionarUnidades() {
        click(todasUnidades);
        click(campoUnidades);
        click(unidadeDepositoJabaquara);
        click(unidadeDepositoBc129);
        click(botaoOk);
    }

    public void selecionarServicos() {
        click(todosServicos);
        click(campoServico);
        click(servicoJantar);
        click(servicoRetiradas);
        click(servicoJanta);
        click(botaoOk);
    }

    public void selecionarMeses() {
        clicarCampoSelecionarValor(campoMesInicial, mesMaio);
        clicarCampoSelecionarValor(campoMesFinal, mesJulho);
    }

    public void selecionarMesesIncorretos() {
        clicarCampoSelecionarValor(campoMesInicial, mesJulho);
        clicarCampoSelecionarValor(campoMesFinal, mesMaio);
        click(botaoRelatorio);

        String mensagemAlerta = getText(campoMensagemAlerta);
        String mensagemEsperada = "O mês inicial deve ser menor ou igual ao mês final.";
        Assert.assertEquals(mensagemAlerta, mensagemEsperada, "Verificação da mensagem exbida na tela após selecionar o mês inicial maior que o final");
        click(botaoOkAlerta);
    }

    public void verificarCamposObrigatorios() {
        click(botaoCampoRelatorio);
        click(todasUnidades);
        click(todosServicos);
        click(botaoMesInicinal);
        click(botaoMesFinal);
        click(botaoRelatorio);

        //mensagens encontradas
        String relatorio = getText(mensagemObrigatorioRelatorio);
        String unidade = getText(mensagemObrigatorioUnidade);
        String servico = getText(mensagemObrigatorioServico);
        String mesInicial = getText(mensagemObrigatorioMesInicial);
        String mesFinal = getText(mensagemObrigatorioMesFinal);

        String mensagemEsperada = "Campo obrigatório";
        Assert.assertEquals(relatorio, mensagemEsperada, "Verificação mensagem de campo obrigatório no campo 'relatório'");
        Assert.assertEquals(unidade, mensagemEsperada, "Verificação mensagem de campo obrigatório no campo 'unidade'");
        Assert.assertEquals(servico, mensagemEsperada, "Verificação mensagem de campo obrigatório no campo 'serviço'");
        Assert.assertEquals(mesInicial, mensagemEsperada, "Verificação mensagem de campo obrigatório no campo 'mês inicial'");
        Assert.assertEquals(mesFinal, mensagemEsperada, "Verificação mensagem de campo obrigatório no campo 'mês final'");
    }

    public void gerarRelatorio() {
        tempo();
        click(botaoRelatorio);
        click(tipoPdf);
        click(botaoConfirmar);
        fecharGuiaDoRelatorio();
    }


    private void fecharGuiaDoRelatorio() {
        tempo();
        tempo();

        String winHandleBefore = driver.getWindowHandle();
        List<String> aba = new ArrayList<>(driver.getWindowHandles());
        driver.switchTo().window(aba.get(1));
        driver.getCurrentUrl();
        driver.close();
        driver.switchTo().window(winHandleBefore);
    }

}
