package com.javaseleniumtemplate.pages;

import com.javaseleniumtemplate.bases.PageBase;

import org.openqa.selenium.By;

public class GrupoTipodePratoPage extends PageBase {

    By loginInfoTextArea = By.xpath("//*[@class = 'navbar-brand zh-header-title has-header-info']");
    By msgConfirmaTela = By.xpath("//div[@class = 'navbar-brand zh-header-title has-header-info']");
    By botaoInicial = By.xpath("//*[@type = 'button']");
    By displayInicio = By.xpath("//*[@type = 'button']");
    By clicarBotao = By.xpath("//*[@class = 'menu-link'] //*[contains(text(),'Parametrização')]");

    By clicaPlanejamento = By.xpath("//ul[@class = 'sub-menu']//*[contains(text(),'Planejamento')]");

    By clicaEmPrato = By.xpath("//ul[@class = 'sub-menu']//li[@class = 'menu-item closed sub-menu-item has-child visible']//span[@class = 'menu-link']//*[contains(text(),'Prato')]");
    By clicaGrupoTipoPrato = By.xpath("//ul[@class = 'sub-menu']//li[@ng-repeat='menu in _menu.menus']//span[@class = 'menu-link']//*[contains(text(),'Grupo de Tipo de Prato')]");
    By botaoAdicionar = By.xpath("//*[@id='footer']/div[2]/ul/li[1]");
    By codigoGrupo = By.xpath("//*[@id = 'CDGRTIPOPR']");
    By nomeGrupo   = By.xpath("//*[@id = 'NMGRTIPOPR']");
    By botaoSalvar = By.xpath("//span[contains(text(),'Salvar')]");
    By grupoCadastrado = By.xpath("//*[@id='grid-173759315227064145484383']/div[2]/div/div[9]/div[2]/span");
    By grupoCadastrado2 = By.xpath("//*[@id='grid-173759315227064145484383']/div[2]/div/div[10]/div[2]/span");
    By mensagemAlertOk = By.xpath("//button[@class = 'zh-alert-button']");
    By btnCancelar = By.xpath("//span[text() = 'Cancelar']");

    By clicaGrupo01 = By.xpath("//*[@id='grid-173759315227064145484383']/div[2]/div/div[1]/div[2]/div");
    By editarGrupo01 = By.xpath("//*[@id='grid-173759315227064145484383']/div[2]/div/div[1]/div[2]/div/input");
    By clicaGrupo02 = By.xpath("//*[@id='grid-173759315227064145484383']/div[2]/div/div[2]/div[2]/div");
    By editarGrupo02 = By.xpath("//*[@id='grid-173759315227064145484383']/div[2]/div/div[2]/div[2]/div/input");
    By btnSalvarAlteracoes = By.xpath("//span[text() = 'Salvar alterações']");

    By mensagemEncontrada = By.xpath("//*[@id='grid-173759315227064145484383']/div[2]/div/div[1]/div[2]/span");
    By msgEncontrada = By.xpath("//*[@id='grid-173759315227064145484383']/div[2]/div/div[2]/div[2]/span");

    By clicaRegistrorelacionado = By.xpath("//*[@id='grid-173759315227064145484383']/div[2]/div/div[1]");
    By btnExcluirGrupo = By.xpath("//li[@data-zh-id='173759315232055125904390']");
    By btnConfirmaExclusao = By.xpath("//button[@class = 'zh-alert-button horizontal']//span[text() = 'Sim']");
    By clicaGrupoGuarnicao = By.xpath("//span[text() = '20']");
    By clicaGrupoSalada = By.xpath("//span[text() = '30']");

    By mensagemEsperada = By.xpath("//*[@class='zh-notification-messages']");



    public void acessarTela() {
     tempo();
     click(botaoInicial);
     click(clicarBotao);
     click(clicaPlanejamento);
     waitForVisibilityOfElementLocated(clicaEmPrato);
     click(clicaEmPrato);
     waitForVisibilityOfElementLocated(clicaGrupoTipoPrato);
     click(clicaGrupoTipoPrato);
     tempo();

    }

    public void validaCamposObrigatorio(String CDCODIGO, String NMGRUPO){
        tempo();
        click(botaoAdicionar);
        tempo();
        click(botaoSalvar);
        tempo();
        clickPerform(codigoGrupo);
        clearAndSendKeys(codigoGrupo,CDCODIGO);
        tempo();
        click(botaoSalvar);
        clickPerform(nomeGrupo);
        clearAndSendKeys(nomeGrupo,NMGRUPO);
        click(codigoGrupo);
        clear(codigoGrupo);
        tempo();
        click(botaoSalvar);
        tempo();
        click(btnCancelar);
        tempo();
    }

    public void insereGrupoTipoPrato(String CDCODIGO, String NMGRUPO){
        tempo();
        click(botaoAdicionar);
        tempo();
        click(codigoGrupo);
        clearAndSendKeys(codigoGrupo,CDCODIGO);
        tempo();
        click(nomeGrupo);
        clearAndSendKeys(nomeGrupo,NMGRUPO);
        tempo();
        click(botaoSalvar);
        tempo();
    }

    public String retornaCadastroGrupo(){
        return getText(grupoCadastrado);
    }

    public String retornaCadastroGrupo2(){return getText(grupoCadastrado2);}

    public void validaRegistroIgual(String CDCODIGO, String NMGRUPO){
        tempo();
        click(botaoAdicionar);
        tempo();
        click(codigoGrupo);
        clearAndSendKeys(codigoGrupo,CDCODIGO);
        tempo();
        click(nomeGrupo);
        clearAndSendKeys(nomeGrupo,NMGRUPO);
        tempo();
        click(botaoSalvar);
        tempo();
        click(mensagemAlertOk);
        tempo();
        click(btnCancelar);
        tempo();
    }

    public void salvarSemNome(){
        tempo();
        click(clicaGrupo01);
        clear(editarGrupo01);
        click(clicaGrupo02);
        clear(editarGrupo02);
        tempo();
        click(btnSalvarAlteracoes);
        tempo();
        click(mensagemAlertOk);
        tempo();

    }

    public void editarESalvar(String NMGRUPO01, String NMGRUPO02){
        tempo();
        click(clicaGrupo01);
        clearAndSendKeys(editarGrupo01,NMGRUPO01);
        click(clicaGrupo02);
        clearAndSendKeys(editarGrupo02,NMGRUPO02);
        tempo();
        click(btnSalvarAlteracoes);
        tempo();

    }

    public String validaCadastroGrupo01(){
        return getText(mensagemEncontrada);
    }

    public String validaCadastroGrupo02(){
        return getText(msgEncontrada);
    }

    public void excluirRegistroRelacionado(){
        tempo();
        click(clicaRegistrorelacionado);
        tempo();
        click(btnExcluirGrupo);
        tempo();
        click(btnConfirmaExclusao);
        tempo();
        click(mensagemAlertOk);
        tempo();

    }

    public void excluirRegistroGuarnicao(){
        tempo();
        click(clicaGrupoGuarnicao);
        tempo();
        click(btnExcluirGrupo);
        tempo();
        click(btnConfirmaExclusao);
        tempo();
    }

    public void excluirRegistroSalada(){
        tempo();
        click(clicaGrupoSalada);
        tempo();
        click(btnExcluirGrupo);
        tempo();
        click(btnConfirmaExclusao);
        tempo();
    }

    public String validaExclusao(){return getText(mensagemEsperada);}




}


