package com.javaseleniumtemplate.pages;

import com.javaseleniumtemplate.bases.PageBase;
import org.openqa.selenium.By;
import org.testng.Assert;

import java.util.ArrayList;
import java.util.List;

public class HistoricoAjusteCardapioPage extends PageBase {

    By botaoMenu = By.xpath("//div[@class='bars']");
    By campoPesquisar = By.xpath("//section[@class='zh-container-search-menu']//input[@type='text']");
    By telaHistoricoAjusteCardapio = By.xpath("//span[text() = 'Histórico Ajuste de Cardápio']");

    By botaoCampoRelatorio = By.xpath("//div[@id=\"REPORTNAME\"]//span[@style=\"background-image: none; display: block;\"]");
    By campoRelatorio = By.id("REPORTNAME");
    By relatorioHistoricoAjusteCardapio = By.xpath("//div[@data-zh-id=\"169603725333912590584840\"]//div[@class=\"list-items show-select\"]//span[text() = 'Histórico Ajuste de Cardápio']");
    By relatorioAderenciaPercentual = By.xpath("//div[@data-zh-id=\"169603725333912590584840\"]//div[@class=\"list-items show-select\"]//span[text() = 'Aderência de Cardápio (Percentual)']");
    By relatorioAderenciaTipoPratoPercentual = By.xpath("//div[@data-zh-id=\"169603725333912590584840\"]//div[@class=\"list-items show-select\"]//span[text() = 'Aderência de Cardápio por Tipo de Prato (Percentual)']");
    By relatorioAlteracoesCardapio = By.xpath("//div[@data-zh-id=\"169603725333912590584840\"]//div[@class=\"list-items show-select\"]//span[text() = 'Alterações do Cardápio']");
    By relatorioLogAlteracoes = By.xpath("//div[@data-zh-id=\"169603725333912590584840\"]//div[@class=\"list-items show-select\"]//span[text() = 'Log de Alterações no Cardápio']");
    By relatorioModificacaoComensais = By.xpath("//div[@data-zh-id=\"169603725333912590584840\"]//div[@class=\"list-items show-select\"]//span[text() = 'Modificação em Comensais']");
    By relatorioModificacaoPratos = By.xpath("//div[@data-zh-id=\"169603725333912590584840\"]//div[@class=\"list-items show-select\"]//span[text() = 'Modificação em Pratos']");

    By campoAgrupamentoUnidades = By.id("NMGRUPFILI");
    By agrupamentoProdutoAcabado = By.xpath("//div[@data-zh-id=\"169603725331696795784841\"]//span[text() = '0000000001 | PRODUCAO - PRODUTO ACABADO']");

    By todasUnidades = By.xpath("//label[@for=\"zh-checkbox-TFILIAL\"]//div[@class=\"zh-box mousetrap zh-ripple-effect\"]");
    By campoUnidade = By.id("NMFILIAL");
    By unidadeFarmaciaBc121 = By.xpath("//div[@data-zh-field-name=\"NMFILIAL\"]//span[text() = 'FARMACIA BC 121']");
    By unidadeDepositoBc111 = By.xpath("//div[@data-zh-field-name=\"NMFILIAL\"]//span[text() = 'DEPOSITO BC 111']");

    By todosServicos = By.xpath("//label[@for=\"zh-checkbox-TSERVICO\"]//div[@class=\"zh-box mousetrap zh-ripple-effect\"]");
    By campoServico = By.id("SERVICO");
    By servicoSolicitacao = By.xpath("//div[@data-zh-field-name=\"NMSERVICO\"]//span[text() = 'SOLICITACAO']");
    By servicoDistribuicao = By.xpath("//div[@data-zh-field-name=\"NMSERVICO\"]//span[text() = 'DISTRIBUICAO']");

    By todosTipoPrato = By.xpath("//label[@for=\"zh-checkbox-TTIPOPRAT\"]//div[@class=\"zh-box mousetrap zh-ripple-effect\"]");
    By campoTipoPrato = By.id("NMTIPOPRAT");
    By tipoPratoArroz = By.xpath("//div[@data-zh-field-name=\"NMTIPOPRAT\"]//span[text() = 'ARROZ']");
    By tipoPratoPrincipal = By.xpath("//div[@data-zh-field-name=\"NMTIPOPRAT\"]//span[text() = 'PRATO PRINCIPAL']");
    By tipoPratoFeijao = By.xpath("//div[@data-zh-field-name=\"NMTIPOPRAT\"]//span[text() = 'FEIJAO']");
    By tipoPratoSobremesa = By.xpath("//div[@data-zh-field-name=\"NMTIPOPRAT\"]//span[text() = 'SOBREMESA']");

    By botaoOk = By.xpath("//section[@class='popup-container']//div[@class='zh-footer-right']//span[text() = 'Ok']");
    By botaoCampoCardapioDe = By.xpath("//div[@id=\"DTMESCARD\"]//span[@style=\"background-image: none; display: block;\"]");
    By campoPercentualMinimoAnuncio = By.id("VRPERCENT");

    By campoCardapioDe = By.id("DTMESCARD");
    By anoCalendario = By.xpath("//section[@class=\"calendar month-picker zh-calendar-widget\"]//h3[@class=\"calendar-heading\"]");
    By mesNovembro = By.xpath("//div[@class=\"calendar\"]//div[@class=\"month\"]//div[text() = 'Nov']");
    By botaoDiminuirAno = By.xpath("//section[@class=\"calendar month-picker zh-calendar-widget\"]//div[@zh-click=\"navigateDate(-1)\"]");

    By mensagemObrigatorioRelatorio = By.xpath("//div[@data-zh-id=\"169603725333912590584840\"]//div[@class=\"zh-validation\"]/span");
    By mensagemObrigatorioUnidade = By.xpath("//div[@data-zh-id=\"169603725311726705104845\"]//div[@class=\"zh-validation\"]/span");
    By mensagemObrigatorioServico = By.xpath("//div[@data-zh-id=\"16960372535205071044852\"]//div[@class=\"zh-validation\"]/span");
    By mensagemObrigatorioTipoPrato = By.xpath("//div[@data-zh-id=\"169603725318489520814858\"]//div[@class=\"zh-validation\"]/span");
    By mensagemObrigatorioCardapioDe = By.xpath("//div[@data-zh-id=\"169603725317774839404864\"]//div[@class=\"zh-validation\"]/span");

    By tipoPdf = By.xpath("//label[@for='radio-QR2TYPE-PDF']//div[@contenteditable='true']");
    By botaoRelatorio = By.xpath("//div[@class='zh-footer-right']");
    By botaoConfirmar = By.xpath("//section[@id='popup']//span[text() = 'Confirmar']");

    public void acessarTela() {
        tempoParaAguardarTelaInicial();
        waitForElement(botaoMenu);
        tempo();
        click(botaoMenu);
        sendKeys(campoPesquisar, "Histórico Ajuste de Cardápio");
        click(telaHistoricoAjusteCardapio);
    }

    public void selecionarRelatorio(String nomeRelatorio) {
        if (nomeRelatorio == "Histórico Ajuste de Cardápio") {
            clicarCampoSelecionarValor(campoRelatorio, relatorioHistoricoAjusteCardapio);
        } else if (nomeRelatorio == "Aderência de Cardápio (Percentual)") {
            clicarCampoSelecionarValor(campoRelatorio, relatorioAderenciaPercentual);
        } else if (nomeRelatorio == "Aderência de Cardápio por Tipo de Prato (Percentual)") {
            clicarCampoSelecionarValor(campoRelatorio, relatorioAderenciaTipoPratoPercentual);
        } else if (nomeRelatorio == "Alterações do Cardápio") {
            clicarCampoSelecionarValor(campoRelatorio, relatorioAlteracoesCardapio);
        } else if (nomeRelatorio == "Log de Alterações no Cardápio") {
            clicarCampoSelecionarValor(campoRelatorio, relatorioLogAlteracoes);
        } else if (nomeRelatorio == "Modificação em Comensais") {
            clicarCampoSelecionarValor(campoRelatorio, relatorioModificacaoComensais);
        } else if (nomeRelatorio == "Modificação em Pratos") {
            click(campoRelatorio);
            javaScriptExecutor.executeScript("document.querySelector(\"body > span > section > section > div.default-window > section.everything > div > section > section > div > form > section > div > div:nth-child(1) > div > div > div.list-items.show-select\").scrollBy(0, 100)");
            click(relatorioModificacaoPratos);
        }
    }

    public void selecionarAgrupamentoProdutoAcabado() {
        clicarCampoSelecionarValor(campoAgrupamentoUnidades, agrupamentoProdutoAcabado);
    }

    public void selecionarTodasUnidades() {
        click(todasUnidades);
    }

    public void selecionarUnidades() {
        click(todasUnidades);
        click(campoUnidade);
        click(unidadeFarmaciaBc121);
        click(unidadeDepositoBc111);
        click(botaoOk);
    }

    public void selecionarServicos() {
        click(todosServicos);
        click(campoServico);
        click(servicoDistribuicao);
        javaScriptExecutor.executeScript("document.querySelector(\"#grid-9999 > div.grid-vertical-scroll-control\").scrollBy(0, 200)");
        click(servicoSolicitacao);
        click(botaoOk);
    }

    public void selecionarTipoPrato() {
        click(todosTipoPrato);
        click(campoTipoPrato);
        click(tipoPratoArroz);
        click(tipoPratoPrincipal);
        click(tipoPratoFeijao);
        click(tipoPratoSobremesa);
        click(botaoOk);
    }

    public void campoObrigatorios() {
        click(botaoCampoRelatorio);
        click(todosServicos);
        click(todosTipoPrato);
        click(botaoCampoCardapioDe);
        click(botaoRelatorio);

        //mensagens encontradas nos campos obrigatórios
        String relatorio = getText(mensagemObrigatorioRelatorio);
        String unidade = getText(mensagemObrigatorioUnidade);
        String servico = getText(mensagemObrigatorioServico);
        String tipoPrato = getText(mensagemObrigatorioTipoPrato);
        String cardapioDe = getText(mensagemObrigatorioCardapioDe);

        String mensagemEsperada = "Campo obrigatório";
        Assert.assertEquals(relatorio, mensagemEsperada, "Verificação mensagem de campo obrigatório no campo relatório, com o relatório");
        Assert.assertEquals(unidade, mensagemEsperada, "Verificação mensagem de campo obrigatório no campo unidade, com o relatório");
        Assert.assertEquals(servico, mensagemEsperada, "Verificação mensagem de campo obrigatório no campo serviço, com o relatório");
        Assert.assertEquals(tipoPrato, mensagemEsperada, "Verificação mensagem de campo obrigatório no campo tipo de prato, com o relatório");
        Assert.assertEquals(cardapioDe, mensagemEsperada, "Verificação mensagem de campo obrigatório no campo cardápio de, com o relatório");

    }

    public void preencherPercentualMinimo() {
        clearAndSendKeys(campoPercentualMinimoAnuncio, "7,9");
        click(todasUnidades);

        String valorPercentual = driver.findElement(campoPercentualMinimoAnuncio).getAttribute("value");
        Assert.assertEquals(valorPercentual, "7,90", "Verificação do valor do campo percentual minímo de ajustes, após a edição");
    }

    public void selecionarNovembro2023() {
        click(campoCardapioDe);
        while (Integer.parseInt(getText(anoCalendario)) > 2023) {
            click(botaoDiminuirAno);
        }
        click(mesNovembro);
    }

    public void geraRelatorio() {
        super.geraRelatorio(botaoRelatorio, tipoPdf, botaoConfirmar);
        fecharGuiaDoRelatorio();
    }

    private void fecharGuiaDoRelatorio() {
        tempo();
        tempo();
        String winHandleBefore = driver.getWindowHandle();
        List<String> aba = new ArrayList<>(driver.getWindowHandles());
        driver.switchTo().window(aba.get(1));
        driver.getCurrentUrl();
        driver.close();
        driver.switchTo().window(winHandleBefore);
    }

}
