package com.javaseleniumtemplate.pages;

import com.javaseleniumtemplate.bases.PageBase;
import org.openqa.selenium.By;
import org.openqa.selenium.interactions.Actions;

public class PadraoDeGrupoDePratoPage extends PageBase {

    By clicaMenu = By.xpath("//*[@id='header']/div[1]/div[2]/div[1]/a");
    By msgEncontrada = By.xpath("//*[@id='header']/div/div[2]/div[3]");
    By procurarTela = By.xpath("//section[@class = 'zh-container-search-menu']/input");
    By selecionaTela = By.xpath("//span[text() = 'Padrão de Grupo de Prato']");
    By confirmaAcessoTela = By.xpath("//div[text() = 'Padrão de Grupo de Prato']");

    //Tipo
    By clicaCampoTipo = By.xpath("//*[@id='popup']/span/section/section/section/div/form/section[1]/div/div/div/div/div[2]");
    By tipoContrato = By.xpath("//li[text() = 'Contrato']");
    By tipoPlanejado = By.xpath("//li[text() = 'Planejado']");
    By btnAplicarFiltro = By.xpath("//span[text() = 'Aplicar filtro']");

    //Adicionar Grupo
    By btnAdicionar = By.xpath("//li[@data-zh-id='41781530514837376891850']");
    By codigoGrupo = By.xpath("//input[@id = 'CDPADGRUPOPRATO']");
    By nomeGrupo = By.xpath("//input[@id = 'NMPADGRUPOPRATO']");
    By btnSalvarEProximo = By.xpath("//span[text() = 'Salvar e Próximo']");
    By btnCancelar = By.xpath("//span[text() = 'Cancelar']");
    By alertOk = By.xpath("//button[@class = 'zh-alert-button']");

    By msgEncontradaGrupo_2 = By.xpath("//*[@id='grid-41781530537801939851847']/div[2]/div/div[2]/div[2]");
    By msgEncontradaGrupo_3 = By.xpath("//*[@id='grid-41781530537801939851847']/div[2]/div/div[3]/div[2]");
    By msgEncontradaGrupo_4 = By.xpath("//*[@id='grid-41781530537801939851847']/div[2]/div/div[4]/div[2]");

    //Edição registros
    By clicaGrupoAlmoco = By.xpath("//*[@id='grid-41781530537801939851847']/div[2]/div/div[2]/div[3]/div");
    By editaNomeGrupoAlmoco = By.xpath("//*[@id='grid-41781530537801939851847']/div[2]/div/div[2]/div[3]/div/input");
    By clicaGrupoJanta = By.xpath("//*[@id='grid-41781530537801939851847']/div[2]/div/div[3]/div[3]/div");
    By editaNomeGrupoJanta = By.xpath("//*[@id='grid-41781530537801939851847']/div[2]/div/div[3]/div[3]/div/input");
    By clicaGrupoDesjejum = By.xpath("//*[@id='grid-41781530537801939851847']/div[2]/div/div[4]/div[3]/div");
    By editaNomeGrupoDesjejum = By.xpath("//*[@id='grid-41781530537801939851847']/div[2]/div/div[4]/div[3]/div/input");
    By btnSalvarAlteracoes = By.xpath("//span[text() = 'Salvar alterações']");
    By btnConfirmaAlteracao = By.xpath("//button[@class = 'zh-alert-button horizontal']//span[text() = 'Sim']");
    By nomeAlteradoGrupo_2 = By.xpath("//*[@id='grid-41781530537801939851847']/div[2]/div/div[2]/div[3]/span");
    By nomeAlteradoGrupo_3 = By.xpath("//*[@id='grid-41781530537801939851847']/div[2]/div/div[3]/div[3]/span");
    By nomeAlteradoGrupo_4 = By.xpath("//*[@id='grid-41781530537801939851847']/div[2]/div/div[4]/div[3]/span");

    //Excluir Registros
    By marcaRegistroGrupo_2 = By.xpath("//*[@id='grid-41781530537801939851847']/div[2]/div/div[2]/div[1]");
    By marcaRegistroGrupo_3 = By.xpath("//*[@id='grid-41781530537801939851847']/div[2]/div/div[3]/div[1]");
    By marcaRegistroGrupo_4 = By.xpath("//*[@id='grid-41781530537801939851847']/div[2]/div/div[4]/div[1]");
    By btnExcluir = By.xpath("//li[@data-zh-id='41781530537935824601852']");
    By btnConfirmaExclusao = By.xpath("//button[@class = 'zh-alert-button horizontal']//span[text() = 'Sim']");
    By getAlertSucessoExclusao = By.xpath("//*[@class='zh-notification-messages']");

    public void acessarTelaPadrao(){
        waitForVisibilityOfElementLocated(msgEncontrada);
        tempo();
        click(clicaMenu);
        tempo();
        click(procurarTela);
        sendKeys(procurarTela,"Padrão de Grupo de Prato");
        tempo();
        click(selecionaTela);
    }

    public String acessoTela(){
        return getText(confirmaAcessoTela);
    }

    public void realizarFiltro(String nome){
        tempo();
        click(clicaCampoTipo);
        tempo();
        if (nome == "Contrato") {
            click(tipoContrato);
            tempo();
        }else{
        click(tipoPlanejado);
        tempo();
        }
        click(btnAplicarFiltro);
        tempo();
    }

    public void validarCamposObrigatorios(){
        click(btnAdicionar);
        tempo();
        click(btnSalvarEProximo);

    }

    public void cadastraGrupo(){
        Actions actions = new Actions(driver);
        tempo();
        actions.moveToElement(driver.findElement(codigoGrupo), -110, 0).click().build().perform();
        clearAndSendKeys(codigoGrupo,"0000000001");
        clickPerform(nomeGrupo);
        clearAndSendKeys(nomeGrupo,"ALMOÇO");
        click(btnSalvarEProximo);
        tempo();
        click(alertOk);
        click(codigoGrupo);
        clearAndSendKeys(codigoGrupo,"0000000002");
        click(btnSalvarEProximo);
        tempo();
        click(codigoGrupo);
        clearAndSendKeys(codigoGrupo,"0000000003");
        click(nomeGrupo);
        clearAndSendKeys(nomeGrupo,"JANTAR");
        click(btnSalvarEProximo);
        tempo();
        click(codigoGrupo);
        clearAndSendKeys(codigoGrupo,"0000000004");
        click(nomeGrupo);
        clearAndSendKeys(nomeGrupo,"DESJEJUM");
        click(btnSalvarEProximo);
        tempo();
        click(btnCancelar);
        tempo();


    }

    public String validaCadastroGrupo_2(){
        return getText(msgEncontradaGrupo_2);
    }

    public String validaCadastroGrupo_3(){
        return getText(msgEncontradaGrupo_3);
    }

    public String validaCadastroGrupo_4(){
        return getText(msgEncontradaGrupo_4);
    }

    public void editarNomeGrupo(){
        tempo();
        click(clicaGrupoAlmoco);
        click(editaNomeGrupoAlmoco);
        clearAndSendKeys(editaNomeGrupoAlmoco,"LANCHE NOITE");
        click(clicaGrupoJanta);
        click(editaNomeGrupoJanta);
        clearAndSendKeys(editaNomeGrupoJanta,"REFEIÇÃO");
        click(clicaGrupoDesjejum);
        click(editaNomeGrupoDesjejum);
        clearAndSendKeys(editaNomeGrupoDesjejum,"LANCHE TARDE");
        tempo();
        click(btnSalvarAlteracoes);
        tempo();
        click(btnConfirmaAlteracao);
        tempo();

    }

    public String validaAlteracaoGrupo_2(){
        return getText(nomeAlteradoGrupo_2);
    }

    public String validaAlteracaoGrupo_3(){
        return getText(nomeAlteradoGrupo_3);
    }

    public String validaAlteracaoGrupo_4(){
        return getText(nomeAlteradoGrupo_4);
    }

    public void excluirPadraoGrupoDePrato(){
        tempo();
        click(marcaRegistroGrupo_2);
        click(marcaRegistroGrupo_3);
        click(marcaRegistroGrupo_4);
        tempo();
        click(btnExcluir);
        tempo();
        click(btnConfirmaExclusao);
        tempo();
    }

    public String mensagemEncontrada(){
        return getText(getAlertSucessoExclusao);
    }




}
