package com.javaseleniumtemplate.tests;

import com.javaseleniumtemplate.bases.TestBase;
import com.javaseleniumtemplate.flows.AnaliseRequisicaoProjecaoFlows;
import com.javaseleniumtemplate.flows.LoginFlows;
import com.javaseleniumtemplate.pages.AnaliseRequisicaoProjecaoPage;
import org.testng.annotations.Test;

public class AnaliseRequisicaoProjecaoTests extends TestBase {

    AnaliseRequisicaoProjecaoPage analiseRequisicaoProjecaoPage;
    AnaliseRequisicaoProjecaoFlows analiseRequisicaoProjecaoFlows;
    LoginFlows loginFlows;

    //acessar a tela 'Análise de Requisição Projeção'
    //clicar no campo relatório e selecionar o relatório 'Análise de Requisição - Projeção'
    //clicar no campo unidade e selecionar unidade DEPOSITO BC 129, preencher a data inicial e final
    //clicar no botão do campo produto inicial, pesquisar pelo código do produto CREOSOTO e selecionar o mesmo
    //clicar no botão do campo produto final, pesquisar pelo código do produto PENEIRA ARROZ 55 CM INOX VITORIA
    //clicar no check-box da opção gerar solicitação de compras, para selecionar a mesma
    //clicar no campo tipo de custo e selecionar o tipo 'Custo Médio Bruto Atual'
    //Verificar o valor apresentado no campo tipo de custo, após selecionar o tipo de custo desejado
    //clicar no botão relatório, pdf e confirmar, fechar a guia do relatório que será gerado
    //clicar nos check-box de considerar e deixar apenas a opção 'Requisição' selecionada, gerar novamente o relatório e fechar a guia do mesmo
    //clicar nos check-box de considerar e deixar apenas a opção 'Estoque' selecionada, gerar novamente o relatório e fechar a guia do mesmo
    //clicar nos check-box de considerar e deixar apenas a opção 'AF' selecionada, gerar novamente o relatório e fechar a guia do mesmo
    @Test
    public void gerarRelatorio() {
        analiseRequisicaoProjecaoPage = new AnaliseRequisicaoProjecaoPage();
        analiseRequisicaoProjecaoFlows = new AnaliseRequisicaoProjecaoFlows();
        loginFlows = new LoginFlows();

        String dataInicial = "01/10/2023";
        String dataFinal = "31/12/2023";

        loginFlows.efetuarLogin();
        analiseRequisicaoProjecaoFlows.navegateAnaliseRequisicaoProjecao();
        analiseRequisicaoProjecaoPage.selecionarRelatorio();
        analiseRequisicaoProjecaoPage.selecionarUnidade();
        analiseRequisicaoProjecaoPage.preencherDatas(dataInicial, dataFinal);
        analiseRequisicaoProjecaoPage.selecionarProdutos();
        analiseRequisicaoProjecaoPage.selecionarGerarSolicitacaoCompras();
        analiseRequisicaoProjecaoPage.selecionarTipoCusto();
        analiseRequisicaoProjecaoPage.geraRelatorio();

        analiseRequisicaoProjecaoPage.considerar("Requisição");
        analiseRequisicaoProjecaoPage.geraRelatorio();
        analiseRequisicaoProjecaoPage.considerar("Estoque");
        analiseRequisicaoProjecaoPage.geraRelatorio();
        analiseRequisicaoProjecaoPage.considerar("AF");
        analiseRequisicaoProjecaoPage.geraRelatorio();
    }


    //acessar a tela 'Análise de Requisição Projeção'
    //clicar no botão do campo data de levantamento, clicar no botão do campo tipo de custo, clicar no botão relatório
    //verificar a mensagem exibida na tela informando para preencher os campos obrigatórios, clicar em ok
    //verificar a mensagem de campo obrigatório nos campos unidade, data de levantamento, produto inicial, produto final e tipo de custo
    //recarregar a página, clicar no campo unidade e selecionar a unidade DEPOSITO BC 129, preencher a data inicial e final
    //clicar no botão do campo produto inicial, pesquisar pelo código do produto CREOSOTO e selecionar o mesmo
    //clicar no botão do campo produto final, pesquisar pelo código do produto PENEIRA ARROZ 55 CM INOX VITORIA
    //desmarcar todas as oções de Considerar (requisição, estoque e AF), clicar no botão relatório, verificar a mensagem exibida na tela informando que considerar deve ser informado, clicar em ok
    @Test
    public void camposObrigatorios() {
        analiseRequisicaoProjecaoPage = new AnaliseRequisicaoProjecaoPage();
        analiseRequisicaoProjecaoFlows = new AnaliseRequisicaoProjecaoFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        analiseRequisicaoProjecaoFlows.navegateAnaliseRequisicaoProjecao();
        analiseRequisicaoProjecaoPage.camposObrigatorios();

        analiseRequisicaoProjecaoPage.refresh();
        analiseRequisicaoProjecaoPage.selecionarUnidade();
        analiseRequisicaoProjecaoPage.preencherDatas("01/01/2024", "31/01/2024");
        analiseRequisicaoProjecaoPage.selecionarProdutos();
        analiseRequisicaoProjecaoPage.obrigatorioConsiderar();
    }


}