package com.javaseleniumtemplate.tests;

import com.javaseleniumtemplate.bases.TestBase;
import com.javaseleniumtemplate.flows.AnaliseRestricoesContratuaisFlows;
import com.javaseleniumtemplate.flows.LoginFlows;
import com.javaseleniumtemplate.pages.AnaliseRestricoesContratuaisPage;
import org.testng.annotations.Test;

public class AnaliseRestricoesContratuaisTests extends TestBase {

    AnaliseRestricoesContratuaisPage analiseRestricoesContratuaisPage;
    AnaliseRestricoesContratuaisFlows analiseRestricoesContratuaisFlows;
    LoginFlows loginFlows;

//        Frequência de Grupo de Pratos Analítico (Mês)
//        Frequência de Grupo de Pratos Sintético (Mês)
//        Frequência de Grupo de Pratos Analítico (Semana)
//        Frequência de Grupo de Pratos Sintético (Semana)
//        Limite Per Capita por Serviço Analítico
//        Limite Per Capita por Serviço Sintético
//        Frequência de Produtos por Grupo de Prato Analítico (Mês)
//        Frequência de Produtos por Grupo de Prato Sintético (Mês)
//        Frequência de Produtos por Grupo de Prato Analítico (Semana)
//        Frequência de Produtos por Grupo de Prato Sintético (Semana)
//        Frequência de Pratos Analítico (Mês)
//        Frequência de Pratos Sintético (Mês)
//        Frequência de Pratos Analítico (Semana)
//        Frequência de Pratos Sintético (Semana)
//        Frequência de Opções por Grupo de Prato Analítico (Mês)
//        Frequência de Opções por Grupo de Prato Sintético (Mês)
//        Frequência de Opções por Grupo de Prato Analítico (Semana)
//        Frequência de Opções por Grupo de Prato Sintético (Semana)
//        Restrições de Produtos por Grupo de Prato Analítico
//        Restrições de Produtos por Grupo de Prato Sintético


    @Test
    public void relatorioGrupoPratoAnaliticoMes() {
        gerarRelatorio("Frequência de Grupo de Pratos Analítico (Mês)");
    }

    @Test
    public void relatorioGrupoPratoSinteticoMes() {
        gerarRelatorio("Frequência de Grupo de Pratos Sintético (Mês)");
    }

    @Test
    public void relatorioGrupoPratoAnaliticoSemana() {
        gerarRelatorio("Frequência de Grupo de Pratos Analítico (Semana)");
    }

    @Test
    public void relatorioGrupoPratoSinteticoSemana() {
        gerarRelatorio("Frequência de Grupo de Pratos Sintético (Semana)");
    }

    @Test
    public void relatorioLimitePerCapServAnalitico() {
        gerarRelatorio("Limite Per Capita por Serviço Analítico");
    }

    @Test
    public void relatorioLimitePerCapServSintetico() {
        gerarRelatorio("Limite Per Capita por Serviço Sintético");
    }

    @Test
    public void relatorioProdutosGrupoPratoAnaliticoMes() {
        gerarRelatorio("Frequência de Produtos por Grupo de Prato Analítico (Mês)");
    }

    @Test
    public void relatorioProdutosGrupoPratoSinteticoMes() {
        gerarRelatorio("Frequência de Produtos por Grupo de Prato Sintético (Mês)");
    }

    @Test
    public void relatorioProdutoGrupoPratoAnaliticoSemana() {
        gerarRelatorio("Frequência de Produtos por Grupo de Prato Analítico (Semana)");
    }

    @Test
    public void relatorioProdutoGrupoPratoSinteticoSemana() {
        gerarRelatorio("Frequência de Produtos por Grupo de Prato Sintético (Semana)");
    }

    @Test
    public void relatorioPratoAnaliticoMes() {
        gerarRelatorio("Frequência de Pratos Analítico (Mês)");
    }

    @Test
    public void relatorioPratoSinteticoMes() {
        gerarRelatorio("Frequência de Pratos Sintético (Mês)");
    }

    @Test
    public void relatorioPratoAnaliticoSemana() {
        gerarRelatorio("Frequência de Pratos Analítico (Semana)");
    }

    @Test
    public void relatorioPratoSinteticoSemana() {
        gerarRelatorio("Frequência de Pratos Sintético (Semana)");
    }

    @Test
    public void relatorioOpcoesGrupoPratoAnaliticoMes() {
        gerarRelatorio("Frequência de Opções por Grupo de Prato Analítico (Mês)");
    }

    @Test
    public void relatorioOpcoesGrupoPratoSinteticoMes() {
        gerarRelatorio("Frequência de Opções por Grupo de Prato Sintético (Mês)");
    }

    @Test
    public void relatorioOpcoesGrupoPratoAnaliticoSemana() {
        gerarRelatorio("Frequência de Opções por Grupo de Prato Analítico (Semana)");
    }

    @Test
    public void relatorioOpcoesGrupoPratoSinteticoSemana() {
        gerarRelatorio("Frequência de Opções por Grupo de Prato Sintético (Semana)");
    }

    @Test
    public void relatorioRestricoesProdGrupoPratoAnalitico() {
        gerarRelatorio("Restrições de Produtos por Grupo de Prato Analítico");
    }

    @Test
    public void relatorioRestricoesProdGrupoPratoSintetico() {
        gerarRelatorio("Restrições de Produtos por Grupo de Prato Sintético");
    }


    //acessar a tela 'Análise de Restrições Contratuais'
    //a função irá receber o nome do relatório que será realizado o teste
    //o relatório que a função recebeu, será selecionado
    //será verificada as opções(contrato e planejado) do campos tipo, será selecionado o contrato
    //irá clicar no campo agrupamento de unidade e será selecionada a opção 'MATERIA PRIMA - MATERIAL DE EMBALAGEM'
    //serão selecionadas as unidades 'Deposito BC 129' e 'Deposito Jabaquara'
    //será selecionado o grupo de serviço geral, os serviços serão 'jantar' e 'retiradas'
    //serão verificadas as opções de ordenação(código e alfabética) clicando nas opções e verificando se foram selecionadas
    //será selecionado o mês de Novembro/2023
    //em alguns relatório nem todos os campos estão habilitados. Esses campos são 'Agrupamento de Prato', 'Grupo de Prato', 'Produto Inicial', 'Produto Final' e a opção 'Exibe apenas produtos divergentes'
    //na função possuí um switch case que verifica o relatório e caso o relatório possua algum desses campos os mesmos serão testados
    //no agrupamento de prato será selecionado o 'SOLICITADOS'
    //o grupo de prato selecionado será o 'jantar'
    //serão selecionados os produtos inicial e final
    //será verificado se por padrão o check-box 'Exibe apenas Produtos Divergentes' vem desmarcado, irá clicar no mesmo e verificar se passa a estar marcado
    //irá clicar no botão relatório, tipo pdf, gerar o relatório e fechar a guia do mesmo
    public void gerarRelatorio(String nomeRelatorio) {
        analiseRestricoesContratuaisPage = new AnaliseRestricoesContratuaisPage();
        analiseRestricoesContratuaisFlows = new AnaliseRestricoesContratuaisFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        analiseRestricoesContratuaisFlows.navegateAnaliseRestricoesContratuais();
        analiseRestricoesContratuaisPage.selecionarRelatorio(nomeRelatorio);
        analiseRestricoesContratuaisPage.selecionarTipo("Contrato");
        analiseRestricoesContratuaisPage.selecionarAgrupUnMateriaPrima();
        analiseRestricoesContratuaisPage.selecionarUnidades();
        analiseRestricoesContratuaisPage.selecionarGrupoServico();
        analiseRestricoesContratuaisPage.selecionarServicos();
        analiseRestricoesContratuaisPage.verificarOrdenacao();
        analiseRestricoesContratuaisPage.selecionarMesNovembro2023();

        switch (nomeRelatorio) {
            //campos desabilitados: produto inicial, produto final e exibe apenas produtos divergentes
            case "Frequência de Grupo de Pratos Analítico (Mês)":
            case "Frequência de Grupo de Pratos Sintético (Mês)":
            case "Frequência de Grupo de Pratos Analítico (Semana)":
            case "Frequência de Grupo de Pratos Sintético (Semana)":
            case "Frequência de Opções por Grupo de Prato Analítico (Mês)":
            case "Frequência de Opções por Grupo de Prato Sintético (Mês)":
            case "Frequência de Opções por Grupo de Prato Analítico (Semana)":
            case "Frequência de Opções por Grupo de Prato Sintético (Semana)":
                analiseRestricoesContratuaisPage.selecionarAgrupamentoPrato();
                analiseRestricoesContratuaisPage.selecionarGrupoPrato();
                break;

            //todos os campos habilitados
            case "Limite Per Capita por Serviço Analítico":
            case "Limite Per Capita por Serviço Sintético":
            case "Frequência de Produtos por Grupo de Prato Analítico (Mês)":
            case "Frequência de Produtos por Grupo de Prato Sintético (Mês)":
            case "Frequência de Produtos por Grupo de Prato Analítico (Semana)":
            case "Frequência de Produtos por Grupo de Prato Sintético (Semana)":
                analiseRestricoesContratuaisPage.selecionarAgrupamentoPrato();
                analiseRestricoesContratuaisPage.selecionarGrupoPrato();
                analiseRestricoesContratuaisPage.selecionarProdutos();
                analiseRestricoesContratuaisPage.verificaProdutosDivergentes();
                break;

            //campo desabilitado sem exibir apenas produtos divergentes
            case "Restrições de Produtos por Grupo de Prato Analítico":
            case "Restrições de Produtos por Grupo de Prato Sintético":
                analiseRestricoesContratuaisPage.selecionarAgrupamentoPrato();
                analiseRestricoesContratuaisPage.selecionarGrupoPrato();
                analiseRestricoesContratuaisPage.selecionarProdutos();
                break;

            //os relatórios: Frequência de Pratos Analítico (Mês) /  Frequência de Pratos Sintético (Mês)   /
            //Frequência de Pratos Analítico (Semana) /  Frequência de Pratos Sintético (Semana)
            //possuem os seguintes campos desabilitados: agrupamento de prato, grupo de prato, produto inicial, produto final e exibir apenas produtos divergentes
            //por isso estes relatórios não estão presentes no switch case
        }

        analiseRestricoesContratuaisPage.geraRelatorio();

    }





    //acessar a tela 'Análise de Restrições Contratuais'
    //será selecionado o relatório e verificado se os campos da tela estão habilitados ou não
    //os campos são: tipo, agrupamento de unidades, unidade, grupo de serviço, serviço, agrupamento de prato, grupo de prato, mês, produto inicial, produto final e Exibe apenas Produtos Divergentes
    //como alguns campos estão habilitados para alguns relatórios e para outros não. O teste possui um switch case, que define quais campos esperam estar habilitados ou não, de acordo com o relatório selecionado
    //após a verificação ser concluída, a tela é atualizada, é selecionado um novo relatório e feita novamente a verificação de todos os campos
    //de acordo com o relatório irá variar se o campo deve estar habilitado ou não
    @Test
    public void camposHabilitados() {
        analiseRestricoesContratuaisPage = new AnaliseRestricoesContratuaisPage();
        analiseRestricoesContratuaisFlows = new AnaliseRestricoesContratuaisFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        analiseRestricoesContratuaisFlows.navegateAnaliseRestricoesContratuais();
        analiseRestricoesContratuaisPage.camposHabilitados();
    }


    //acessar a tela 'Análise de Restrições Contratuais'
    //clicar na unidade que por padrão já vem selecionada na tela, para que o campo unidade fique vazio
    //clicar no botão do campo mês, para que este campo também fique vazios
    //clicar no botão 'relatório'
    //verificar a mensagem de campo obrigatório nos campos: tipo, unidade, serviço, mês
    //os campos produto inicial e final também são obrigatórios, mas como não está habilitado em todos os relatório,
    //o teste possui um switch case que verifica caso seja algum relatório que tenha este campo habilitado, será verificada também a mensagem nestes 2 campos
    //após concluída a verificação, a tela será atualizada, será selecionado um novo relatório, feito novamente o processo para deixar os campos unidade e mês vazios
    //irá clicar no botão relatório, verificar a mensagem de campo obrigatório
    //essa verificação ocorrerá com todos os relatórios da tela
    @Test
    public void camposObrigatorios() {
        analiseRestricoesContratuaisPage = new AnaliseRestricoesContratuaisPage();
        analiseRestricoesContratuaisFlows = new AnaliseRestricoesContratuaisFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        analiseRestricoesContratuaisFlows.navegateAnaliseRestricoesContratuais();
        analiseRestricoesContratuaisPage.camposObrigatorios();
    }

}