package com.javaseleniumtemplate.tests;

import com.javaseleniumtemplate.bases.TestBase;
import com.javaseleniumtemplate.flows.LoginFlows;
import com.javaseleniumtemplate.flows.CategoriaEmbalagemFlows;
import com.javaseleniumtemplate.pages.CategoriaEmbalagemPage;
import org.testng.annotations.Test;

public class CategoriaEmbalagemTests extends TestBase {

    CategoriaEmbalagemPage categoriaEmbalagemPage;
    CategoriaEmbalagemFlows categoriaEmbalagemFlows;
    LoginFlows loginFlows;


    //acessar a tela 'Categoria de Embalagens'
    //clicar no botão adicionar, preencher os campos (código e nome) e clicar em salvar
    //pesquisar no filtro o código da categoria adicionada e verificar se os dados foram salvos corretamente
    //clicar no check-box da categoria que foi adicionada, clicar em excluir, verificar a mensagem exibida na tela, clicar em sim
    //verificar a mensagem de excluído com sucesso, exibida no canto da tela
    @Test
    public void adicionarExcluir() {
        categoriaEmbalagemPage = new CategoriaEmbalagemPage();
        categoriaEmbalagemFlows = new CategoriaEmbalagemFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        categoriaEmbalagemFlows.navegateTelaCategoriaEmbalagens();
        categoriaEmbalagemPage.adicionarCategoria();
        categoriaEmbalagemPage.excluirCategoria();
    }


    //acessar a tela 'Categoria de Embalagens'
    //pesquisar pelo código 00004
    //clicar sobre o nome da categoria, alterar o nome, clicar em salvar alterações
    //verificar a mensagem de salvo com sucesso, exibida no canto da tela
    //verificar se o novo nome da categoria foi salvo corretamente
    //editar novamente o nome da categoria, para que o mesmo volte a ser o nome que estava no início do teste
    //verificar se a alterações foi salva com sucesso
    @Test
    public void editarNomeCategoria() {
        categoriaEmbalagemPage = new CategoriaEmbalagemPage();
        categoriaEmbalagemFlows = new CategoriaEmbalagemFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        categoriaEmbalagemFlows.navegateTelaCategoriaEmbalagens();
        categoriaEmbalagemPage.editarCategoria();
    }


    //acessar a tela 'Categoria de Embalagens'
    //clicar no botão adicionar
    //tentar adicionar uma categoria com o código 3 e verificar a mensagem exibida na tela informando que este código já existe
    //clicar no botão ok e também no botão cancelar
    @Test
    public void codigoExistente() {
        categoriaEmbalagemPage = new CategoriaEmbalagemPage();
        categoriaEmbalagemFlows = new CategoriaEmbalagemFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        categoriaEmbalagemFlows.navegateTelaCategoriaEmbalagens();
        categoriaEmbalagemPage.tentarAdicionarCodigoExistente();
    }


    //acessar a tela 'Categoria de Embalagens'
    //clicar no botão adicionar e salvar
    //verificar a mensagem de campo obrigatório nos campos código e nome
    //clicar no botão cancelar
    @Test
    public void camposObrigatorios() {
        categoriaEmbalagemPage = new CategoriaEmbalagemPage();
        categoriaEmbalagemFlows = new CategoriaEmbalagemFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        categoriaEmbalagemFlows.navegateTelaCategoriaEmbalagens();
        categoriaEmbalagemPage.camposObrigatorios();
    }


    //acessar a tela 'Categoria de Embalagens'
    //pesquisar no filtro pelo código 00001
    //clicar no check-box da categoria com este código, clicar em excluir
    //verificar a mensagem exibida na tela sobre a exclusão e clicar e sim
    //verificar a mensagem exibida na tela informando que a exclusão não é permitida pois a categoria possui registro filho
    //verificar se está categoria não foi removida
    @Test
    public void tentarExcluirCategoriaComRegistroFilho() {
        categoriaEmbalagemPage = new CategoriaEmbalagemPage();
        categoriaEmbalagemFlows = new CategoriaEmbalagemFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        categoriaEmbalagemFlows.navegateTelaCategoriaEmbalagens();
        categoriaEmbalagemPage.tentarExcluirCategoriaComRegistrosFilhos();
    }


    //acessar a tela 'Categoria de Embalagens'
    //no filtro inicial procurar pelo código 02
    //clicar no campo nome, deixar o mesmo vazio, clicar em salvar
    //recarregar a página procurar pelo código 02
    //verificar se o nome da categoria deste código não foi alterada
    @Test
    public void tentarAlterarESalvarCategoriaComNomeVazio() {
        categoriaEmbalagemPage = new CategoriaEmbalagemPage();
        categoriaEmbalagemFlows = new CategoriaEmbalagemFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        categoriaEmbalagemFlows.navegateTelaCategoriaEmbalagens();
        categoriaEmbalagemPage.tentarDeixarNomeVazio();
    }

}
