package com.javaseleniumtemplate.tests;

import com.javaseleniumtemplate.bases.TestBase;
import com.javaseleniumtemplate.flows.LoginFlows;
import com.javaseleniumtemplate.flows.CicloFlows;
import com.javaseleniumtemplate.pages.CicloPage;
import org.testng.annotations.Test;

public class CicloTests extends TestBase {

    CicloPage cicloPage;
    CicloFlows cicloFlows;
    LoginFlows loginFlows;


    //acessar a tela 'Ciclo'
    //clicar no botão adicionar
    //preencher os campos código e nome, inserir o valor 3 no número de semanas
    //selecionar o dia quarta, para o início do ciclo
    //clicar em salvar e verificar a mensagem de salvo com sucesso informada no canto da tela
    //clicar em voltar
    //preencher o filtro com o código (00005) do ciclo adicionado
    //verificar se as informações (código, nome, número de semanas, número de cardápios, início do ciclo e ativo) foram salvas corretamente
    //clicar no botão excluir, verificar a mensagem exibida na tela perguntando se deseja excluir o registro
    //clicar em sim e verificar a mensagem de excluído com sucesso exibida no canto da tela
    //verificar a mensagem de nenhum registro encontrado, após a exclusão do ciclo adicionado
    @Test
    public void adicionarVerificarExcluirCiclo() {
        cicloPage = new CicloPage();
        cicloFlows = new CicloFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        cicloFlows.navegateTelaCiclo();
        cicloPage.adicionarCiclo1();
        cicloPage.verificarCicloAdicionado1();
        cicloPage.excluirCicloAdicionado1();
    }


    //acessar a tela 'Ciclo'
    //no filtro início pesquisar pelo código (00003)
    //clicar no campo do nome do ciclo e inserir um novo nome para ele
    //clicar no inline-checkbox do ciclo para que o mesmo passe a não estar mais ativo
    //clicar no botão salvar e verificar a mensagem de salvo com sucesso, exibida no canto da tela
    //verificar se o nome alterado foi salvo com sucesso e se o 'ativo' passou a não estar mais ativo
    //alterar novamente o nome e clicar no inline-checkbox do ativo deste ciclo e clicar em salvar, para que as informações fiquem da forma que estavam no início do ciclo
    //verificar se o nome e ativos foram salvos corretamente
    @Test
    public void editarNomeAtivoCicloTelaInicial() {
        cicloPage = new CicloPage();
        cicloFlows = new CicloFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        cicloFlows.navegateTelaCiclo();
        cicloPage.editarNomeAtivoCiclo1();
    }


    //acessar a tela 'Ciclo'
    //preencher o filtro da tela inicial com o código (00003)
    //clicar no ciclo, clicar na aba 'ciclo' e clicar em editar
    //alterar o nome do clico e clicar no check-box ativo
    //clicar em salvar e verificar a mensagem de salvo com sucesso exibida no canto da tela
    //clicar na aba ciclo e verificar se o nome do ciclo foi salvo corretamente e verificar se o ativo não está mais selecionado
    //clicar em editar e retornar o nome do ciclo, para o nome que estava no início do teste e clicar no ativo, para deixa-lo selecionado da forma que estava
    //clicar em salvar, clicar na aba ciclo e verificar se as alterações foram salvas corretamente
    @Test
    public void editarNomeAtivoAcessandoCiclo() {
        cicloPage = new CicloPage();
        cicloFlows = new CicloFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        cicloFlows.navegateTelaCiclo();
        cicloPage.edtarAcessandoCiclo();
    }

    //acessar a tela 'Ciclo'
    //no filtro inicial da tela, pesquisar pelo código 00003
    //acessar o ciclo encontrado
    //clicar no botão adicionar, clicar no padrão ciclo 'VENDAS', selecionar os tipos de prato arroz e salada, clicar no botão incluir
    //verificar a mensagem de registro adicionado com sucesso apresentada no canto da tela
    //verificar se o nome e a opção dos tipos de pratos e a opção dos mesmos foram salvas corretamente
    //clicar no botão voltar e verificar o código e nome do padrão de ciclo adicionado
    //clicar no código do padrão de ciclo, clicar no botão excluir dos tipos de prato e selecionar os 2 que foram adicionados
    //verificar se na aba padrão de ciclo é apresentada a mensagem de não há registros
    @Test
    public void adicionarVerificarExcluirPadraoCiclo() {
        cicloPage = new CicloPage();
        cicloFlows = new CicloFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        cicloFlows.navegateTelaCiclo();
        cicloPage.adicionarPadraoCiclo1();
        cicloPage.verificarPadraoCicloAdd1();
        cicloPage.excluirTipoPratoPadraoCiclo1();
    }


    //acessar a tela 'Ciclo'
    //no filtro inicial da tela pesquisar pelo código (00001)
    //clicar no botão excluir, verificar a mensagem exibida na tela, clicar no botão sim
    //verificar a mensagem exibida na tela informando que a exclusão não é permitida, pois possui registros filho
    //clicar no botão ok
    //verificar se o ciclo não foi excluído
    @Test
    public void tentarExcluirCicloComRegistroFilho() {
        cicloPage = new CicloPage();
        cicloFlows = new CicloFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        cicloFlows.navegateTelaCiclo();
        cicloPage.tentarExcluirCicloComRegFilho1();
    }


    //acessar a tela 'Ciclo'
    //no filtro inicial pesquisar pelo código (00002)
    //acessar o ciclo, clicar no check-box do padrão de ciclo
    //clicar no botão excluir, verificar a mensagem exibida na tela, clicar no botão sim
    //verificar a mensagem exibida na tela informando que a exclusão não é permitida, pois possui registros filho
    //clicar no botão ok
    //verificar se o padrão de ciclo não foi excluído
    @Test
    public void tentarExcluirPadraoCicloComRegFilho() {
        cicloPage = new CicloPage();
        cicloFlows = new CicloFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        cicloFlows.navegateTelaCiclo();
        cicloPage.tentarExcluirPadraoCicloComRegFilho1();
    }


    //acessar a tela 'Ciclo'
    //no filtro inicial pesquisar pelo código (00004)
    //acessar o clico, acessar o padrão de ciclo
    //inserir um valor no campo complemento, clicar no inline-checked de opção do tipo de prato
    //clicar em salvar
    //verificar se o nome do complemento foi salvo corretamente e se a opção passou a estar ativada
    //apagar o valor do campo complemente e clicar no inline-checked de opção e clicar em salvar para que os valores voltem a ser os mesmos do início do teste
    //verificar se o complemento e a opção foram salvos corretamente
    @Test
    public void editarConfigPadraoCiclo() {
        cicloPage = new CicloPage();
        cicloFlows = new CicloFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        cicloFlows.navegateTelaCiclo();
        cicloPage.editarConfiguracaoPadraoCiclo();
    }


    //acessar a tela 'Ciclo'
    //clicar no botão adicionar preencher o campo código com o valor 1 (código já cadastrado) e preencher o campo nome
    //clicar em salvar e verificar a mensagem de alerta exibida na tela informando que o registro já existe
    //clicar no botão ok e clicar no botão cancelar
    @Test
    public void tentarAddCicloCodigoRepetido() {
        cicloPage = new CicloPage();
        cicloFlows = new CicloFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        cicloFlows.navegateTelaCiclo();
        cicloPage.tentarAddCicloCodigoRepetido();
    }


    //acessar a tela 'Ciclo'
    //clicar no botão adicionar e clicar no botão salvar
    //verificas as mensagem de campo obrigatório nos campos (código e nome)
    //clicar no botão cancelar
    @Test
    public void camposObrigatorios() {
        cicloPage = new CicloPage();
        cicloFlows = new CicloFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        cicloFlows.navegateTelaCiclo();
        cicloPage.campoObrigatoriosFormAddCiclo1();
    }

}