package com.javaseleniumtemplate.tests;

import com.javaseleniumtemplate.bases.TestBase;
import com.javaseleniumtemplate.flows.ElaboracaoCardapioFlows;
import com.javaseleniumtemplate.flows.LoginFlows;
import com.javaseleniumtemplate.pages.ElaboraCardapioPage;
import org.testng.Assert;
import org.testng.annotations.Test;
import sun.awt.windows.ThemeReader;

public class ElaboracaoCardapioTests extends TestBase {
    ElaboraCardapioPage elaboracaocardapiopage;
    ElaboracaoCardapioFlows elaboracaoFlows;
    LoginFlows loginFlows;


    public void acessarTelaElaboracaoCardapio(){
        loginFlows = new LoginFlows();
        elaboracaoFlows = new ElaboracaoCardapioFlows();
        String msgEsperada = "Seleção do Cardápio";
        loginFlows.efetuarLogin();
        elaboracaoFlows.NavegaElaboracaoCardapio();
        Assert.assertEquals(elaboracaoFlows.validarAcessoTela(),msgEsperada,"Falha ao acessar tela: ");
    }


    public void realizarFiltroElaboracao(String CDFILIAl, String CDSERVFILI, String TIPOCOMENSAIS,String CDEXIBECUSTO, String DATATIPOCUSTO,String DTREFERENCIA){
        String MSGESPERADA = "Elaboração do Cardápio";
        elaboracaoFlows.filtrarUnidade(CDFILIAl);
        elaboracaoFlows.filtrarServico(CDSERVFILI);
        elaboracaoFlows.mesCardapio();
        elaboracaoFlows.montagemCardadioAtraves(TIPOCOMENSAIS);
        elaboracaoFlows.custoCardapioPlanejado();
        elaboracaoFlows.custoCardapioRealizado();
        elaboracaoFlows.custoComBaseData(CDEXIBECUSTO,DATATIPOCUSTO,DTREFERENCIA);
        elaboracaoFlows.confirmaFiltroCardapio();
//        Assert.assertEquals(elaboracaocardapiopage.mensagemEsperada(),MSGESPERADA,"Acesso a tela de elaboração: ");
    }

   /* TIPOCOMENSAIS - Montagem do cardápio através de N = Número
                                                      P = Percentual

      CDEXIBECUSTO  - CheckBox exibe custo S = Sim
                                           N = Não

      DATATIPOCUSTO - Custo com base em C = Cardapio
                                        R = Data de Referência */
    @Test
    public void validaCamposObrigatorio(){
        String msgCampoObrigatorio = "Campo obrigatório";
        acessarTelaElaboracaoCardapio();
        elaboracaoFlows.limpaCamposFiltro();
        Assert.assertEquals(elaboracaoFlows.msgCampoObrigatrioUnidade(),msgCampoObrigatorio,"Filtro Unidade: ");
        Assert.assertEquals(elaboracaoFlows.msgCampoObrigatrioServico(),msgCampoObrigatorio,"Filtro Serviço: ");
        Assert.assertEquals(elaboracaoFlows.msgCampoObrigatrioMesCard(),msgCampoObrigatorio,"Filtro Cardápio de: ");
        Assert.assertEquals(elaboracaoFlows.msgCampoObrigatrioCustoPla(),msgCampoObrigatorio,"Filtro Custo PLA: ");
        Assert.assertEquals(elaboracaoFlows.msgCampoObrigatrioCustoReal(),msgCampoObrigatorio,"Filtro Custo REAL: ");
        Assert.assertEquals(elaboracaoFlows.msgCampoObrigatrioDataRef(),msgCampoObrigatorio,"Filtro Data Ref.: ");

    }


    @Test
    public void elaborarcardapio(){
        String CDFILIAl = "0002";
        String CDSERVFILI = "00002";
        String TIPOCOMENSAIS = "N";
        String CDEXIBECUSTO = "S";
        String DATATIPOCUSTO = "C";
        String DTREFERENCIA = "26/01/2024";
        String NMPRATO1 = "ARROZ TEMPEREADO";
        String NMPRATO2 = "FEIJAO";
        String NMPRATO3 = "SALADA DE ACELGA";
        acessarTelaElaboracaoCardapio();
        realizarFiltroElaboracao(CDFILIAl,CDSERVFILI,TIPOCOMENSAIS,CDEXIBECUSTO,DATATIPOCUSTO,DTREFERENCIA);
        elaboracaoFlows.elaboraCardapio(NMPRATO1,NMPRATO2,NMPRATO3);

    }


    @Test
    public void analiseDeCorCardapio(){
        String CDFILIAl = "9999";
        String CDSERVFILI = "00002";
        String TIPOCOMENSAIS = "P";
        String CDEXIBECUSTO = "S";
        String DATATIPOCUSTO = "R";
        String DTREFERENCIA = "26/01/2024";
        acessarTelaElaboracaoCardapio();
        realizarFiltroElaboracao(CDFILIAl,CDSERVFILI,TIPOCOMENSAIS,CDEXIBECUSTO,DATATIPOCUSTO,DTREFERENCIA);
        elaboracaoFlows.analiseDeCorCardapio();

    }

    @Test
    public void analisaDeCustos(){
        String CDFILIAl = "9999";
        String CDSERVFILI = "00002";
        String TIPOCOMENSAIS = "P";
        String CDEXIBECUSTO = "S";
        String DATATIPOCUSTO = "R";
        String DTREFERENCIA = "26/01/2024";
        acessarTelaElaboracaoCardapio();
        realizarFiltroElaboracao(CDFILIAl,CDSERVFILI,TIPOCOMENSAIS,CDEXIBECUSTO,DATATIPOCUSTO,DTREFERENCIA);
        elaboracaoFlows.analiseDeCustos();
    }

    @Test
    public void atualizarDataReferencia(){
        String CDFILIAl = "9999";
        String CDSERVFILI = "00002";
        String TIPOCOMENSAIS = "P";
        String CDEXIBECUSTO = "S";
        String DATATIPOCUSTO = "R";
        String DTREFERENCIA = "26/01/2024";
        acessarTelaElaboracaoCardapio();
        realizarFiltroElaboracao(CDFILIAl,CDSERVFILI,TIPOCOMENSAIS,CDEXIBECUSTO,DATATIPOCUSTO,DTREFERENCIA);
        elaboracaoFlows.atualizaDataReferenciaCusto(CDSERVFILI,DTREFERENCIA);
    }

    @Test
    public void atualizarDataReferenciaRecalculoCustos(){
        String CDFILIAl = "9999";
        String CDSERVFILI = "00002";
        String TIPOCOMENSAIS = "P";
        String CDEXIBECUSTO = "S";
        String DATATIPOCUSTO = "R";
        String DTREFERENCIA = "26/01/2024";
        acessarTelaElaboracaoCardapio();
        realizarFiltroElaboracao(CDFILIAl,CDSERVFILI,TIPOCOMENSAIS,CDEXIBECUSTO,DATATIPOCUSTO,DTREFERENCIA);
        elaboracaoFlows.atualizaDataRecalculoCusto(CDSERVFILI,DTREFERENCIA);
    }

    @Test
    public void calcularNutrientesCardapio(){
        String CDFILIAl = "9999";
        String CDSERVFILI = "00002";
        String TIPOCOMENSAIS = "P";
        String CDEXIBECUSTO = "S";
        String DATATIPOCUSTO = "C";
        String DTREFERENCIA = "26/01/2024";
        acessarTelaElaboracaoCardapio();
        realizarFiltroElaboracao(CDFILIAl,CDSERVFILI,TIPOCOMENSAIS,CDEXIBECUSTO,DATATIPOCUSTO,DTREFERENCIA);
        elaboracaoFlows.calcularNutrientes();
    }

    @Test
    public void copiarPratosComensais(){
        String CDFILIAl = "9999";
        String CDSERVFILI = "00002";
        String TIPOCOMENSAIS = "N";
        String CDEXIBECUSTO = "S";
        String DATATIPOCUSTO = "C";
        String DTREFERENCIA = "26/01/2024";

        String CDPRATO = "000000005";
        String COMENSAISSEG = "5";
        String COMENSAISTER = "20";
        String COMENSAISQUA = "20";
        String COMENSAISQUI = "15";
        String COMENSAISSEX = "20";
        String COMENSAISSAB = "0";
        String COMENSAISDOM = "0";
        String COMENSAISFER = "0";
        acessarTelaElaboracaoCardapio();
        realizarFiltroElaboracao(CDFILIAl,CDSERVFILI,TIPOCOMENSAIS,CDEXIBECUSTO,DATATIPOCUSTO,DTREFERENCIA);
        elaboracaoFlows.copiaPratosComensais(CDPRATO,COMENSAISSEG,COMENSAISTER,COMENSAISQUA,COMENSAISQUI,COMENSAISSEX,COMENSAISSAB,COMENSAISDOM,COMENSAISFER);
        elaboracaoFlows.copiarComensais(CDPRATO);
    }

    @Test
    public void exportarCardapioAcrescentar(){
        String CDFILIAl = "9999";
        String CDSERVFILI = "00002";
        String TIPOCOMENSAIS = "P";
        String CDEXIBECUSTO = "S";
        String DATATIPOCUSTO = "C";
        String DTREFERENCIA = "26/01/2024";
        String TIPOACAO = "Acrescentar";

        String CDSERVICOORIGEM = "00002";
        String CDSERVDESTINO = "00001";
        String DTINICIAL = "01/04/2024";
        String DTFINAL = "30/04/2024";
        acessarTelaElaboracaoCardapio();
        realizarFiltroElaboracao(CDFILIAl,CDSERVFILI,TIPOCOMENSAIS,CDEXIBECUSTO,DATATIPOCUSTO,DTREFERENCIA);
        elaboracaoFlows.exportaCardapio(CDSERVICOORIGEM,TIPOACAO,CDSERVDESTINO);
        elaboracaoFlows.excluirCardapioPeriodo(DTINICIAL, DTFINAL);
    }

    @Test
    public void exportarCardapioSobrepor(){
        String CDFILIAl = "9999";
        String CDSERVFILI = "00002";
        String TIPOCOMENSAIS = "P";
        String CDEXIBECUSTO = "S";
        String DATATIPOCUSTO = "C";
        String DTREFERENCIA = "26/01/2024";
        String TIPOACAO = "Sobrepor";

        String CDSERVICOORIGEM = "00002";
        String CDSERVDESTINO = "00001";
        String DTINICIAL = "01/04/2024";
        String DTFINAL = "30/04/2024";
        acessarTelaElaboracaoCardapio();
        realizarFiltroElaboracao(CDFILIAl,CDSERVFILI,TIPOCOMENSAIS,CDEXIBECUSTO,DATATIPOCUSTO,DTREFERENCIA);
        elaboracaoFlows.exportaCardapio(CDSERVICOORIGEM,TIPOACAO,CDSERVDESTINO);
        elaboracaoFlows.excluirCardapioPeriodo(DTINICIAL, DTFINAL);
    }


    @Test
    public void importarCardapioDiaAcrescentar(){
        String CDFILIAl = "0003";
        String CDSERVFILI = "00001";
        String TIPOCOMENSAIS = "N";
        String CDEXIBECUSTO = "S";
        String DATATIPOCUSTO = "R";
        String DTREFERENCIA = "26/01/2024";
        String TIPOCOPIA = "Acrescentar";
        String MSGESPERADA = "Removido com sucesso";

        String CDFILIAL = "9999";
        String CDSERVICOORIGEM = "00002";
        String DTINICIAL = "01/04/2024";
        String DTFINAL = "30/04/2024";
        String DTDESTINO = "01/04/2024";
        acessarTelaElaboracaoCardapio();
        realizarFiltroElaboracao(CDFILIAl,CDSERVFILI,TIPOCOMENSAIS,CDEXIBECUSTO,DATATIPOCUSTO,DTREFERENCIA);
        elaboracaoFlows.importaCardapioDia(CDFILIAL,CDSERVICOORIGEM, CDSERVICOORIGEM,DTINICIAL, DTFINAL, DTDESTINO,TIPOCOPIA);
        elaboracaoFlows.excluirCardapioPeriodo(DTINICIAL, DTFINAL);
       // Assert.assertEquals(elaboracaoFlows.msgConfirmaExclusao(),MSGESPERADA,"Exclusão do cardápio: ");
    }

    @Test
    public void importarCardapioDiaSobrepor(){
        String CDFILIAl = "0003";
        String CDSERVFILI = "00001";
        String TIPOCOMENSAIS = "N";
        String CDEXIBECUSTO = "S";
        String DATATIPOCUSTO = "R";
        String DTREFERENCIA = "26/01/2024";
        String TIPOCOPIA = "Sobrepor";
        String MSGESPERADA = "Removido com sucesso";

        String CDFILIAL = "9999";
        String CDSERVICOORIGEM = "00002";
        String DTINICIAL = "01/04/2024";
        String DTFINAL = "30/04/2024";
        String DTDESTINO = "01/04/2024";
        acessarTelaElaboracaoCardapio();
        realizarFiltroElaboracao(CDFILIAl,CDSERVFILI,TIPOCOMENSAIS,CDEXIBECUSTO,DATATIPOCUSTO,DTREFERENCIA);
        elaboracaoFlows.importaCardapioDia(CDFILIAL,CDSERVICOORIGEM, CDSERVICOORIGEM,DTINICIAL, DTFINAL, DTDESTINO,TIPOCOPIA);
        elaboracaoFlows.excluirCardapioPeriodo(DTINICIAL, DTFINAL);
      //  Assert.assertEquals(elaboracaoFlows.msgConfirmaExclusao(),MSGESPERADA,"Exclusão do cardápio: ");
    }

    @Test
    public void importarTipoDePrato(){
        String CDFILIAl = "0004";
        String CDSERVFILI = "00001";
        String TIPOCOMENSAIS = "P";
        String CDEXIBECUSTO = "S";
        String DATATIPOCUSTO = "C";
        String DTREFERENCIA = "26/01/2024";
        acessarTelaElaboracaoCardapio();
        realizarFiltroElaboracao(CDFILIAl,CDSERVFILI,TIPOCOMENSAIS,CDEXIBECUSTO,DATATIPOCUSTO,DTREFERENCIA);

        String CDFILIAlORIGEM = "9999";
        String CDSERVICOORIGEM = "00002";
        String DTINICIAL = "01/04/2024";
        String DTFINAL = "30/04/2024";
        elaboracaoFlows.importarTipoDePrato(CDFILIAlORIGEM,CDSERVICOORIGEM, DTINICIAL);
        elaboracaoFlows.excluirCardapioPeriodo(DTINICIAL,DTFINAL);
        elaboracaoFlows.configurarCardapio();
    }

    @Test
    public void excluirCardapioDoPeriodo(){
        String CDFILIAl = "0002";
        String CDSERVFILI = "00002";
        String TIPOCOMENSAIS = "P";
        String CDEXIBECUSTO = "S";
        String DATATIPOCUSTO = "C";
        String DTREFERENCIA = "26/01/2024";
        String DTINICIAL = "01/04/2024";
        String DTFINAL = "30/04/2024";
        acessarTelaElaboracaoCardapio();
        realizarFiltroElaboracao(CDFILIAl,CDSERVFILI,TIPOCOMENSAIS,CDEXIBECUSTO,DATATIPOCUSTO,DTREFERENCIA);
        elaboracaoFlows.excluirCardapioPeriodo(DTINICIAL, DTFINAL);

    }

    @Test
    public void inverterPratos(){
        String CDFILIAl = "0002";
        String CDSERVFILI = "00002";
        String TIPOCOMENSAIS = "N";
        String CDEXIBECUSTO = "S";
        String DATATIPOCUSTO = "C";
        String DTREFERENCIA = "26/01/2024";

        String PRATSALADA = "200 - SALADA DE ACELGA";
        String PRATFEIJOADA = "200 - FEIJOADA SIMPLES";

        String NMPRATO = "FEIJOADA SIMPLES";
        String NMPRATO01 = "SALADA";
        String DTINIPRTO = "01/04/2024";
        String DTFIMPRATO = "02/04/2024";

        acessarTelaElaboracaoCardapio();
        realizarFiltroElaboracao(CDFILIAl,CDSERVFILI,TIPOCOMENSAIS,CDEXIBECUSTO,DATATIPOCUSTO,DTREFERENCIA);
        elaboracaoFlows.inverterPratosDia(NMPRATO, NMPRATO01,DTINIPRTO,DTFIMPRATO);
        Assert.assertEquals(elaboracaoFlows.validaPratoInvertido01(),PRATSALADA);
        Assert.assertEquals(elaboracaoFlows.validaPratoInvertido02(),PRATFEIJOADA);
    }

    @Test
    public void adicionarProdutoReceitaLocal(){
        String CDFILIAl = "9999";
        String CDSERVFILI = "00002";
        String TIPOCOMENSAIS = "P";
        String CDEXIBECUSTO = "S";
        String DATATIPOCUSTO = "C";
        String DTREFERENCIA = "26/01/2024";
        String tipoReceita = "Local";
        String CDPRODUTO = "1.01.1.1.01.001.00";
        acessarTelaElaboracaoCardapio();
        realizarFiltroElaboracao(CDFILIAl,CDSERVFILI,TIPOCOMENSAIS,CDEXIBECUSTO,DATATIPOCUSTO,DTREFERENCIA);
        elaboracaoFlows.adicionaProdutoReceita(tipoReceita);
        Assert.assertEquals(elaboracaoFlows.validaProdutoCadastrado(tipoReceita),CDPRODUTO,"Produto receita local: ");
    }

    @Test
    public void revisarReceitaLocalAcrescentar(){
        String CDFILIAl = "9999";
        String CDSERVFILI = "00002";
        String TIPOCOMENSAIS = "P";
        String CDEXIBECUSTO = "S";
        String DATATIPOCUSTO = "C";
        String DTREFERENCIA = "26/01/2024";
        String acaoRevisao = "Acrescentar";
        acessarTelaElaboracaoCardapio();
        realizarFiltroElaboracao(CDFILIAl,CDSERVFILI,TIPOCOMENSAIS,CDEXIBECUSTO,DATATIPOCUSTO,DTREFERENCIA);
        elaboracaoFlows.revisaoReceitaLocal(acaoRevisao);
    }

    @Test
    public void revisarReceitaLocalSobrepor(){
        String CDFILIAl = "9999";
        String CDSERVFILI = "00002";
        String TIPOCOMENSAIS = "P";
        String CDEXIBECUSTO = "S";
        String DATATIPOCUSTO = "C";
        String DTREFERENCIA = "26/01/2024";
        String acaoRevisao = "Sobrepor";
        acessarTelaElaboracaoCardapio();
        realizarFiltroElaboracao(CDFILIAl,CDSERVFILI,TIPOCOMENSAIS,CDEXIBECUSTO,DATATIPOCUSTO,DTREFERENCIA);
        elaboracaoFlows.revisaoReceitaLocal(acaoRevisao);
    }

    @Test
    public void adicionarProdutoReceitaPorServico(){
            String CDFILIAl = "9999";
            String CDSERVFILI = "00002";
            String TIPOCOMENSAIS = "P";
            String CDEXIBECUSTO = "S";
            String DATATIPOCUSTO = "C";
            String DTREFERENCIA = "26/01/2024";
            String CDPRODUTO = "1.01.1.1.01.001.00";
            String tipoReceita = "Serviço";
            acessarTelaElaboracaoCardapio();
            realizarFiltroElaboracao(CDFILIAl,CDSERVFILI,TIPOCOMENSAIS,CDEXIBECUSTO,DATATIPOCUSTO,DTREFERENCIA);
            elaboracaoFlows.adicionaProdutoReceita(tipoReceita);
            Assert.assertEquals(elaboracaoFlows.validaProdutoCadastrado(tipoReceita),CDPRODUTO,"Produto receita local: ");
    }

    @Test
    public void validarProdutoIgualReceitaLocal(){
        String CDFILIAl = "9999";
        String CDSERVFILI = "00002";
        String TIPOCOMENSAIS = "P";
        String CDEXIBECUSTO = "S";
        String DATATIPOCUSTO = "C";
        String DTREFERENCIA = "26/01/2024";
        String tipoReceita = "Local";
        acessarTelaElaboracaoCardapio();
        realizarFiltroElaboracao(CDFILIAl,CDSERVFILI,TIPOCOMENSAIS,CDEXIBECUSTO,DATATIPOCUSTO,DTREFERENCIA);
        elaboracaoFlows.validaCadastroProdutoIgual(tipoReceita);
    }

    @Test
    public void validarProdutoIgualReceitaPorServico(){
        String CDFILIAl = "9999";
        String CDSERVFILI = "00002";
        String TIPOCOMENSAIS = "P";
        String CDEXIBECUSTO = "S";
        String DATATIPOCUSTO = "R";
        String DTREFERENCIA = "26/01/2024";
        String tipoReceita = "Serviço";
        acessarTelaElaboracaoCardapio();
        realizarFiltroElaboracao(CDFILIAl,CDSERVFILI,TIPOCOMENSAIS,CDEXIBECUSTO,DATATIPOCUSTO,DTREFERENCIA);
        elaboracaoFlows.validaCadastroProdutoIgual(tipoReceita);
    }

    @Test
    public void revisarReceitaPorServicoAcrescentar(){
        String CDFILIAl = "9999";
        String CDSERVFILI = "00002";
        String TIPOCOMENSAIS = "P";
        String CDEXIBECUSTO = "S";
        String DATATIPOCUSTO = "C";
        String DTREFERENCIA = "26/01/2024";
        String acaoRevisao = "Acrescentar";
        acessarTelaElaboracaoCardapio();
        realizarFiltroElaboracao(CDFILIAl,CDSERVFILI,TIPOCOMENSAIS,CDEXIBECUSTO,DATATIPOCUSTO,DTREFERENCIA);
        elaboracaoFlows.revisaoDeReceitaPorServico(acaoRevisao);
    }

    @Test
    public void revisarReceitaPorServicoSobrepor(){
        String CDFILIAl = "9999";
        String CDSERVFILI = "00002";
        String TIPOCOMENSAIS = "P";
        String CDEXIBECUSTO = "S";
        String DATATIPOCUSTO = "C";
        String DTREFERENCIA = "26/01/2024";
        String acaoRevisao = "Sobrepor";
        acessarTelaElaboracaoCardapio();
        realizarFiltroElaboracao(CDFILIAl,CDSERVFILI,TIPOCOMENSAIS,CDEXIBECUSTO,DATATIPOCUSTO,DTREFERENCIA);
        elaboracaoFlows.revisaoDeReceitaPorServico(acaoRevisao);
    }

    @Test
    public void informacaoNutricional(){
        String CDFILIAl = "9999";
        String CDSERVFILI = "00002";
        String TIPOCOMENSAIS = "N";
        String CDEXIBECUSTO = "S";
        String DATATIPOCUSTO = "R";
        String DTREFERENCIA = "26/01/2024";
        acessarTelaElaboracaoCardapio();
        realizarFiltroElaboracao(CDFILIAl,CDSERVFILI,TIPOCOMENSAIS,CDEXIBECUSTO,DATATIPOCUSTO,DTREFERENCIA);
        elaboracaoFlows.informacaoNutricionaoPrato();
    }

}
