package com.javaseleniumtemplate.tests;

import com.javaseleniumtemplate.bases.TestBase;
import com.javaseleniumtemplate.flows.IncidenciaCardapioFlows;
import com.javaseleniumtemplate.flows.LoginFlows;
import com.javaseleniumtemplate.pages.IncidenciaCardapioPage;
import org.testng.annotations.Test;

public class IncidenciaCardapioTests extends TestBase {

    IncidenciaCardapioPage incidenciaCardapioPage;
    IncidenciaCardapioFlows incidenciaCardapioFlows;
    LoginFlows loginFlows;


    //acessar a tela 'Incidência de Cardápio'
    //clicar no campo relatório e selecionar o relatório 'Incidência de Cardápio'
    //verificar se os check-box 'Todos' dos campos (unidade, grupo de serviço e serviço) estão selecionados
    //clicar no campo mês inicial e selecionar o mês de Abril de 2024, clicar no campo mês final e selecionar o mês de Maio de 2024
    //clicar no campo nível e selecionar o Nível 1
    //clicar no botão relatório, clicar em pdf, clicar em confirmar e fechar a guia do relatório gerado
    //clicar no check-box 'Todos' do campo unidade, clicar no campo unidade, selecionar as unidades Deposito Jabaquara e Deposito BC 129, clicar no botão ok
    //clicar no check-box 'Todos' do campo grupo de serviço, clicar no campo grupo de serviço, selecionar os grupos: preparos, compras e pedidos, clicar no botão ok
    //clicar no check-box 'Todos' do campo serviço, clicar no campo serviço, selecionar os serviços: palestra, lanche e solicitação, clicar no botão ok
    //clicar no botão do campo prato inicial, pesquisar pelo prato FEIJOADA SIMPLES e selecionar o mesmo
    //clicar no botão do campo prato final, pesquisar pelo prato CAFÉ CREMOSO e selecionar o mesmo
    //clicar no campo tipo de prato, selecionar os tipos: arroz, salada, principal e sobremesa, clicar no botão ok
    //clicar no botão relatório, clicar em pdf, clicar em confirmar e fechar a guia do relatório gerado
    @Test
    public void relatorio() {
        incidenciaCardapioPage = new IncidenciaCardapioPage();
        incidenciaCardapioFlows = new IncidenciaCardapioFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        incidenciaCardapioFlows.navegateIncidenciaCardapio();
        incidenciaCardapioPage.selecionarRelatorioIncidenciaCardapio();
        incidenciaCardapioPage.checkBoxTodosSelecionados();
        incidenciaCardapioPage.selecionarMesesIniFim();
        incidenciaCardapioPage.selecionarNivel();
        incidenciaCardapioPage.gerarRelatorio();
        incidenciaCardapioPage.selecionarUnidades();
        incidenciaCardapioPage.selecionarGrupoServico();
        incidenciaCardapioPage.selecionarServicos();
        incidenciaCardapioPage.selecionarPratoIniFim();
        incidenciaCardapioPage.selecionarTipoPrato();
        incidenciaCardapioPage.gerarRelatorio();
    }


    //acessar a tela 'Incidência de Cardápio'
    //clicar no botão do campo relatório, clicar no check-box 'Todos' dos campos: unidade, grupo de serviço e serviço
    //clicar no botão do campo mês inicial, clicar no botão do campo mês final, clicar no botão relatório
    //verificar a mensagem de 'Campo obrigatório' nos campos: relatório, unidade, grupo de serviço, serviço, mês inicial, mês final e nível
    @Test
    public void camposObrigatorios() {
        incidenciaCardapioPage = new IncidenciaCardapioPage();
        incidenciaCardapioFlows = new IncidenciaCardapioFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        incidenciaCardapioFlows.navegateIncidenciaCardapio();
        incidenciaCardapioPage.camposObrigatorios();
    }


    //acessar a tela 'Incidência de Cardápio'
    //clicar no campo nível, verificar se possuí 4 opções de nível
    //verificar se as opção vão do Nível 1 ao Nível 4
    //selecionar a opção Nível 4 e verificar se a mesma é apresentada no campo nível
    @Test
    public void niveis() {
        incidenciaCardapioPage = new IncidenciaCardapioPage();
        incidenciaCardapioFlows = new IncidenciaCardapioFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        incidenciaCardapioFlows.navegateIncidenciaCardapio();
        incidenciaCardapioPage.verificarNiveis();
    }


    //acessar a tela 'Incidência de Cardápio'
    //clicar no botão do campo prato inicial, clicar no botão do procurar, pesquisar pelo prato CAFÉ CREMOSO e selecionar o mesmo
    //clicar no botão do campo prato final, pesquisar pelo prato FEIJOADA SIMPLES e selecionar o mesmo, clicar no campo nível e selecionar o Nível 1
    //clicar no botão relatório, verificar a mensagem exibida na tela informando que o prato inicial deve ser menor em relação ao prato final, clicar no botão ok
    @Test
    public void pratoInicialDeveSerMenorQueFinal() {
        incidenciaCardapioPage = new IncidenciaCardapioPage();
        incidenciaCardapioFlows = new IncidenciaCardapioFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        incidenciaCardapioFlows.navegateIncidenciaCardapio();
        incidenciaCardapioPage.pratoInicialDeveSerMenorQueFinal();
    }

}