package com.javaseleniumtemplate.tests;

import com.javaseleniumtemplate.bases.TestBase;
import com.javaseleniumtemplate.flows.LoginFlows;
import com.javaseleniumtemplate.flows.NutrientesFlows;
import com.javaseleniumtemplate.pages.NutrientesPage;
import org.testng.annotations.Test;

public class NutrientesTests extends TestBase {

    NutrientesPage nutrientesPage;
    NutrientesFlows nutrientesFlows;
    LoginFlows loginFlows;

    //acessar a tela 'Nutrientes'
    //clicar no botão adicionar, preencher os campos código, nome, sigla, selecionar uma unidade, selecionar um grupo, clicar em salvar
    //verificar a mensagem de salvo com sucesso exibida no canto superior direito da tela
    //procurar pelo código 040 no filtro inicial da tela
    //verificar se os valores(código, nome, sigla, unidade, ordem e grupos) do nutriente foram salvos corretamente
    //clicar no botão editar, verificar se o check-box impressão foi salvo selecionado, clicar em cancelar, clicar em voltar
    //clicar no botão excluir no nutriente adicionado, verificar a mensagem exibida na tela, clicar em sim
    //verificar mensagem de excluído com sucesso exibida no canto superior direito da tela
    //verificar se no grid da lista de nutriente, é informando que nenhum registro foi encontrado
    @Test
    public void adicionarExcluirNutriente() {
        nutrientesPage = new NutrientesPage();
        nutrientesFlows = new NutrientesFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        nutrientesFlows.navegateNutrientes();
        nutrientesPage.adicionarNutriente();
        nutrientesPage.verificarNutrienteAdicionado();
        nutrientesPage.excluirNutriente();
    }


    //acessar a tela 'Nutrientes'
    //procurar pelo código 040 no filtro inicial da tela, clicar no botão editar
    //verificar se o campo código está desabilitado, alterar os valores dos campos (nome, sigla, unidade, ordem e grupos), clicar em salvar
    //verificar mensagem de salvo com sucesso exibida no canto superior direito da tela
    //verificar se os valores (nome, sigla, unidade, ordem e grupo), foram alterados corretamente
    //clicar no botão editar e alterar os valores (nome, sigla, unidade, ordem e grupo) para os que estavam no início do teste
    @Test
    public void editarNutriente() {
        nutrientesPage = new NutrientesPage();
        nutrientesFlows = new NutrientesFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        nutrientesFlows.navegateNutrientes();
        nutrientesPage.editarNutriente();
    }


    //acessar a tela 'Nutrientes'
    //clicar no botão adicionar, limpar o campo ordem
    //verificar se é exibida uma mensagem informando que a ordem não deve ser decimal, clicar no botão ok, clicar em salvar
    //verificar mensagem de campo obrigatório nos campos: código, nome, sigla, unidade, ordem e grupo
    //recarregar a página, clicar no botão adicionar, verificar se os campos (fator cálc. caloria, é caloria, cál.caloria) estão desabilitados
    //verificar se o check-box de impressão estão habilitado e por padrão não vem selecionado
    //clicar no check-box de impressão e verificar se o mesmo passa a estar selecionado
    //recarregar a página, procurar pelo código 021 no filtro inicial da tela, clicar no botão editar
    //limpar o campo nome, limpar o campo sigla, clicar no botão do campo unidade, limpar o campo ordem
    //verificar se é apresentada a mensagem informando que a ordem não deve ser decimal
    //clicar no botão do campo grupo, clicar em salvar
    //verificar a mensagem de campo obrigatório nos campos: nome, sigla, unidade, ordem e grupo
    //clicar em cancelar, clicar em voltar
    @Test
    public void camposObrigatoriosDesabilitados() {
        nutrientesPage = new NutrientesPage();
        nutrientesFlows = new NutrientesFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        nutrientesFlows.navegateNutrientes();
        nutrientesPage.camposObrigatoriosAdicionar();
        nutrientesPage.refresh();
        nutrientesPage.camposDesabilitadosAddNutriente();
        nutrientesPage.refresh();
        nutrientesPage.camposObrigatoriosEditar();
    }


    //acessar a tela 'Nutrientes'
    //clicar no botão adicionar, preencher os campos código (com um código que já foi cadastrado), nome, sigla, selecionar unidade, selecionar grupo
    //clicar em salvar e verificar se é exibida a mensagem informando que é impossível adicionar, pois o registro já existe
    //clicar em ok e clicar em cancelar
    @Test
    public void tentarAdicionarCodigoExistente() {
        nutrientesPage = new NutrientesPage();
        nutrientesFlows = new NutrientesFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        nutrientesFlows.navegateNutrientes();
        nutrientesPage.tentarAdicionarCodigoExistente();
    }


    //acessar a tela 'Nutrientes'
    //procurar pelo código 001 no filtro inicial da tela
    //clicar no botão excluir do nutriente encontrado, verificar a mensagem exibida na tela perguntando se deseja excluir, clicar em sim
    //verificar a mensagem exibida na tela informando que a exclusão não é permitida, pois o registro possuí registros filhos
    //clicar em ok, verificar se o código 001 ainda está na tela, para verificar se o nutriente não foi excluído
    @Test
    public void tentarExcluirNutriRegistrosFilhos() {
        nutrientesPage = new NutrientesPage();
        nutrientesFlows = new NutrientesFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        nutrientesFlows.navegateNutrientes();
        nutrientesPage.tentarExcluirNutriRegistroFilho();
    }

}
