package com.javaseleniumtemplate.tests;

import com.javaseleniumtemplate.bases.TestBase;
import com.javaseleniumtemplate.flows.LoginFlows;
import com.javaseleniumtemplate.flows.RequisicaoServicoAnaliticaFlows;
import com.javaseleniumtemplate.pages.RequisicaoServicoAnaliticaPage;
import org.testng.annotations.Test;

public class RequisicaoServicoAnaliticaTests extends TestBase {

    RequisicaoServicoAnaliticaPage requisicaoServicoAnaliticaPage;
    RequisicaoServicoAnaliticaFlows requisicaoServicoAnaliticaFlows;
    LoginFlows loginFlows;

//    Requisição Analítica (por Serviço)
//    Requisição Analítica (Turnos Por Serviço)
//    Requisição Analítica (por Grupo de Serviço)
//    Requisição Analítica (com Modo de Preparo)
//    Requisição Analítica (por Tipo de Prato/Prato)
//    Requisição Analítica (Produção)
//    Requisição Analítica (Produção por Grupo de Serviço)
//    Requisição Analítica (Produção Geral)


    @Test
    public void relatorioPorServico() {
        geracaoDoRelatorio("Requisição Analítica (por Serviço)");
    }

    @Test
    public void relatorioTurnosPorServico() {
        geracaoDoRelatorio("Requisição Analítica (Turnos Por Serviço)");
    }

    @Test
    public void relatorioGrupoDeServico() {
        geracaoDoRelatorio("Requisição Analítica (por Grupo de Serviço)");
    }

    @Test
    public void relatorioModoDePreparo() {
        geracaoDoRelatorio("Requisição Analítica (com Modo de Preparo)");
    }

    @Test
    public void relatorioTipoDePrato() {
        geracaoDoRelatorio("Requisição Analítica (por Tipo de Prato/Prato)");
    }

    @Test
    public void relatorioProducao() {
        geracaoDoRelatorio("Requisição Analítica (Produção)");
    }

    @Test
    public void relatorioProducaoPorGrupo() {
        geracaoDoRelatorio("Requisição Analítica (Produção por Grupo de Serviço)");
    }

    @Test
    public void relatorioProducaoGeral() {
        geracaoDoRelatorio("Requisição Analítica (Produção Geral)");
    }


    //acessar a tela Requisição por Serviço Analítica
    //selecionar o relatório que foi passado como parâmetros
    //preencher as datas inicial e final
    //gerar o relatórios com a opção 'Todos' dos campos 'grupos de serviço' e 'serviço' selecionados
    //fechar a guia do relatório e atualizar a tela
    //selecionar novamente o relatório, preencher as datas inicial e final e também alguns 'grupos de serviço' e 'serviço' de forma manual
    //preencher o percentual de acréscimo
    //gerar o relatório e fechar a guia do relatório gerado
    public void geracaoDoRelatorio(String nomeRelatorio) {
        requisicaoServicoAnaliticaPage = new RequisicaoServicoAnaliticaPage();
        requisicaoServicoAnaliticaFlows = new RequisicaoServicoAnaliticaFlows();
        loginFlows = new LoginFlows();

        String dataInicial = "01/05/2023";
        String dataFinal = "31/05/2023";

        loginFlows.efetuarLogin();
        requisicaoServicoAnaliticaFlows.navegateRequisicaoServicoAnalitica();
        requisicaoServicoAnaliticaPage.selecionaRelatorio(nomeRelatorio);
        requisicaoServicoAnaliticaPage.preencherDatas(dataInicial, dataFinal);
        requisicaoServicoAnaliticaPage.geraRelatorio();
        requisicaoServicoAnaliticaPage.refresh();
        requisicaoServicoAnaliticaPage.selecionaRelatorio(nomeRelatorio);
        requisicaoServicoAnaliticaPage.preencherDatas(dataInicial, dataFinal);
        requisicaoServicoAnaliticaPage.selecionarGrupoServico();
        requisicaoServicoAnaliticaPage.selecionarServico();
        requisicaoServicoAnaliticaPage.preencherPercentualAcressimo();
        requisicaoServicoAnaliticaPage.geraRelatorio();
    }


    //acessar a tela Requisição por Serviço Analítica
    //verificar se os check-box dos campos: quebra de página, imprimir linhas em branco, imprimir modo de preparo padrão, arredondar qtde. dos produtos, cardápio, consumo fixo e consumo per capita, estão habilitados ou não
    //clicar nos check-box e verificar se os mesmos passam a estar selecionados ou não
    //essa verificação dos check-box é realizada para todos os relatório. É selecionado o primeiro relatório e feita toda verificação, ao fim a tela é recarregada, selecionado o segundo relatório e feita toda verificação
    //a tela é atualizada novamente, selecionado o próximo relatório e feita toda verificação para todos os relatórios
    //atualizar a tela, clicar no check-box linhas em branco, verificar se o campo com o número de linhas passa a estar habilitado, preencher o campo e verificar se após clicar fora do campo, o valor não é alterado
    //deixar os campos(data, unidade, grupo de serviço e serviço) vazios, clicar em relatório e verificar a mensagem de campo obrigatório nos campos que foram deixados vazios
    //deixar o tipo de consumo sem nenhuma opção selecionada, clicar em relatório e verificar a mensagem exibida na tela
    //verificar se com a ordenação 'código', o campo 'nível' está desabilitado
    //clicar na ordenação, 'alfabética por nível' e verificar se o campo 'nível' passa a estar habilitado e tem as opções de 0 a 5
    @Test
    public void testesComplementares() {
        requisicaoServicoAnaliticaPage = new RequisicaoServicoAnaliticaPage();
        requisicaoServicoAnaliticaFlows = new RequisicaoServicoAnaliticaFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        requisicaoServicoAnaliticaFlows.navegateRequisicaoServicoAnalitica();
        requisicaoServicoAnaliticaPage.verificarCheckBoxs();
        requisicaoServicoAnaliticaPage.refresh();
        requisicaoServicoAnaliticaPage.verificarQuantLinhasBranco();
        requisicaoServicoAnaliticaPage.verificarCampoObrigatorios();
        requisicaoServicoAnaliticaPage.verificarOrdenacao();
    }

}
